// Redline.cpp : Defines the entry point for the DLL application.
//

//#include "stdafx.h"
#include <Redline.h>
#include <verite.h>
#include <redline.h>
#include <vex.h>
#include  <rlfifoex.h>
#include <stdio.h>




bool libraryLoaded=false;
bool veriteInit=false;

__declspec(dllexport) bool noFlush=false;



CRITICAL_SECTION oCS;
FILE *log=NULL;




typedef vl_error  (*VL_OpenVeriteT)(HWND hwnd, v_handle *pvhandle);

typedef vl_error (*VL_CloseVeriteT) (v_handle vhandle);

typedef vl_error (*VL_WaitForDisplaySwitchT)(v_cmdbuffer *cmdbuffer);

typedef vl_error (*VL_CreateSurfaceT)(v_handle vhandle, 
                                 v_surface **psurface, 
                                 v_u32 buffer_mask, 
                                 v_u32 num_buffers,
                                 v_u32 pixel_fmt, 
                                 v_u32 width, 
                                 v_u32 height);


typedef vl_error (*VL_DestroySurfaceT)(v_handle vhandle, v_surface *surface);


typedef vl_error (*VL_SwapDisplaySurfaceT)(v_cmdbuffer *cmdbuffer, v_surface *surface);


typedef vl_error (*VL_FillBufferT)(v_cmdbuffer *cmdbuffer,
			  v_surface *surface,
			  v_u32 buffer,
			  v_u32 xorg,
			  v_u32 yorg,
			  v_u32 width,
			  v_u32 height,
			  v_u32 pixel_value);



typedef vl_error (*VL_LoadBufferT)(v_cmdbuffer *cmdbuffer,
			      v_surface *surface,
			      v_u32 buffer,
			      v_u32 data_linebytes,
			      v_u32 data_width,
			      v_u32 data_height,
			      v_memory data_memory, v_u32 *data_addr);


typedef vl_error (*VL_InstallDstBufferT)(v_cmdbuffer *cmdbuffer, v_surface *surface);


typedef vl_error (*VL_InstallTextureMapT)(v_cmdbuffer *cmdbuffer, v_surface *surface);


typedef vl_error (*VL_InstallZBufferT)(v_cmdbuffer *cmdbuffer, v_surface *surface);

typedef vl_error (*VL_Setvu32T)(v_cmdbuffer *cmdbuffer, v_u32 src_base);

typedef vl_error (*VL_RectangleT)(v_cmdbuffer *cmdbuffer, v_u32 v_type, v_u32 width, v_u32 height, v_u32 *vert);


typedef vl_error (*VL_TriangleT)(v_cmdbuffer *cmdbuffer, v_u32 v_type, v_u32 *v1, v_u32 *v2, v_u32 *v3);


typedef vl_error (*VL_TristripT)(v_cmdbuffer *cmdbuffer, v_u32 v_type, v_u32 tri_count, v_u32 *verts);
typedef v_u32 (*VL_VertexSizeT)(v_u32 v_type);
typedef vl_error (*VL_FrameMarkerT)(v_cmdbuffer* cmdbuffer, int frame_num);
typedef v_u32 (*V_GetBufferStrideType)(v_buffer_group buffer_group, v_u32 buffer);
typedef v_u32* (*V_AddToCmdListType)(v_cmdbuffer* cmdBuffer, v_u32 num_cmd_entries);
typedef vl_error (*VL_PointSurfaceT) (v_handle vhandle, v_surface **psurface, v_u32 buffer_mask, v_u32 num_buffers, v_u32 pixel_fmt, v_u32 width, v_u32 height, v_foreignAddress addr);
typedef v_foreignAddress (*V_GetBufferAddressT)(v_buffer_group buffer_group, v_u32 buffer);

typedef vl_error(*VL_SetClampT)(v_cmdbuffer* cmdbuffer, v_u32 v_clamp);
VL_SetClampT pVL_SetUClamp = NULL, pVL_SetVClamp = NULL;


//typedef vl_error (*VL_SetSrcFilterT)(v_cmdbuffer *cmdbuffer, v_u32 src_filter);
VL_OpenVeriteT pVL_OpenVerite=NULL;
VL_CloseVeriteT pVL_CloseVerite=NULL;
VL_WaitForDisplaySwitchT pVL_WaitForDisplaySwitch=NULL;
VL_CreateSurfaceT pVL_CreateSurface=NULL;
VL_PointSurfaceT pVL_PointSurface=NULL;
VL_DestroySurfaceT pVL_DestroySurface=NULL;
VL_SwapDisplaySurfaceT pVL_SwapDisplaySurface=NULL;
VL_FillBufferT pVL_FillBuffer=NULL;
VL_LoadBufferT pVL_LoadBuffer=NULL;
VL_InstallDstBufferT pVL_InstallDstBuffer=NULL;
VL_InstallTextureMapT pVL_InstallTextureMap=NULL;
VL_InstallZBufferT pVL_InstallZBuffer=NULL;
VL_Setvu32T pVL_SetSrcBase=NULL;
VL_Setvu32T pVL_SetSrcStride=NULL;
VL_Setvu32T pVL_SetSrcFilter=NULL;
VL_Setvu32T pVL_SetSrcFunc=NULL;
VL_Setvu32T pVL_SetUMask=NULL;
VL_Setvu32T pVL_SetVMask=NULL;
VL_Setvu32T pVL_SetUMultiplier=NULL;
VL_Setvu32T pVL_SetVMultiplier=NULL;
VL_Setvu32T pVL_e=NULL;
VL_Setvu32T pVL_SetBlendSrcFunc=NULL;
VL_Setvu32T pVL_SetBlendDstFunc=NULL;
VL_Setvu32T pVL_SetZBufMode=NULL;
VL_Setvu32T pVL_SetZBufWrMode=NULL;
VL_Setvu32T pVL_SetBlendEnable=NULL;
VL_Setvu32T pVL_SetDitherEnable=NULL;
VL_Setvu32T pVL_SetFogEnable=NULL;
VL_Setvu32T pVL_SetTranspReject=NULL; 
VL_Setvu32T pVL_SetAlphaThreshold=NULL; 
VL_Setvu32T pVL_SetScissorX=NULL;
VL_Setvu32T pVL_SetScissorY=NULL; 
VL_Setvu32T pVL_SetFGColorARGB=NULL;
VL_Setvu32T pVL_SetFogColorRGB=NULL;
VL_Setvu32T pVL_SetZ=NULL;
VL_Setvu32T pVL_SetA=NULL;
VL_Setvu32T pVL_SetF=NULL;
VL_RectangleT pVL_Rectangle=NULL;
VL_TriangleT pVL_Triangle=NULL;
VL_TristripT pVL_Tristrip=NULL;
VL_TristripT pVL_Trifan=NULL;
VL_VertexSizeT pVL_VertexSize=NULL;

VL_FrameMarkerT pVL_FrameMarker=NULL;
V_GetBufferStrideType pV_GetBufferStride=NULL;
V_AddToCmdListType pV_AddToCmdList=NULL;
V_GetBufferAddressT pV_GetBufferAddress=NULL;


#ifdef INDIRECTSRC
bool IndirectSrc(v_cmdbuffer *cmdbuffer, bool rectangle);
#else
#define IndirectSrc(A, B)
#endif

char String[1024];

v_u32 UMASK=0, VMASK=0;
v_u32 UMULT=1, VMULT=1;
v_u32 PIXELFORMAT=4;
v_u32 SRCBASE=0;





//typedef vl_error V_DLLIMPORT (*VL_SetMaskT)(v_cmdbuffer *cmdbuffer, v_u32 mask);
//typedef vl_error V_DLLIMPORT (*VL_SetVMaskT)(v_cmdbuffer *cmdbuffer, v_u32 u_mask);
//VL_SetUMask
bool forceLogFlush=true;
//#define RREADY
#define PUSHPOP
//#define LOGGING
#ifndef LOGGING
#define VLA(a)
#define VLL(a)
#define VLD(a)
#else
#define VLA(a) VL(a)
#define VLL(a) VL(a)
#define VLL(a) VL(a)
#define VLD(a) VL(a)
#endif
//__declspec(dllexport) v_u32 srcStride=0;
//__declspec(dllexport) v_u32 lastSrcStride=0;
//.__declspec(dllexport) v_u32 srcFormat=0;

__declspec(dllexport) void VL(const char *msg)
{
	__asm{
		pushad;
	}

	if(libraryLoaded)
	{
		SYSTEMTIME st;
		GetLocalTime(&st);
		//EnterCriticalSection(&oCS);

		if(forceLogFlush)
			log = fopen("V2k.RReady.Redline.txt", "a");

		fprintf(log, "%02d:%02d:%02d.%03d %s\n", st.wHour, st.wMinute, st.wSecond, st.wMilliseconds, msg);

		fflush(log);

		if(forceLogFlush)
			fclose(log);

		//LeaveCriticalSection(&oCS);
	}

	__asm{
		popad;
	};
}




/*void VLL(const char *s)
{
	VL(s);
}*/

void Error(const char *message)
{
	VL(message);
	//MessageBox(NULL, message, "V1000 Formula 1 Wrapper - Redline.DLL", MB_OK);
}

/*// This is an example of an exported variable
REDLINE_API int nRedline=0;

// This is an example of an exported function.
REDLINE_API int fnRedline(void)
{
	return 42;
}

// This is the constructor of a class that has been exported.
// see Redline.h for the class definition
CRedline::CRedline()
{ 
	return; 
}*/

char tempBuff[1024];
size_t GetVertexSize(v_u32 v_type);

v_handle* pVhandle;
//vhandle = 0;
HWND hwnd;

v_cmdbuffer* cmdbuffer;
v_surface* surface;
v_u32 buffer;
v_u32 xorg;
v_u32 yorg;
v_u32 width;
v_u32 height;
v_u32 pixel_value;

v_handle vhandle;
v_surface** psurface;
v_u32 buffer_mask;
v_u32 num_buffers;
v_u32 pixel_fmt;

vl_error e;

v_u32 dither_enable;
v_u32 z_buf_wr_mode;
v_u32 z_buf_mode;
v_u32 blend_enable;
v_u32 transp_reject;
v_u32 blend_src_func;
v_u32 blend_dst_func;
v_u32 alpha_threshold;
v_u32 src_func;
v_u32 fog_color;
v_u32 fg_color;

v_u32 data_linebytes;
v_u32 data_width;
v_u32 data_height;
v_memory data_memory;
v_u32* data_addr;
v_memory memory;
v_u32 fog_enable;
v_u32 v_type;
v_u32* vert;
v_u32 src_filter;
v_u32 u_mult;
v_u32 v_mult;
v_u32 vert_count;
v_u32 *v1, *v2, *v3;
bool paletted=false;
bool clamped = false;

char buff[MAX_PATH];

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
			{
				VL("DllMain Process Detach");
			/*GetSystemDirectory(buff, MAX_PATH);
			int len = strlen(buff);
			if(buff[len-1] != '\\')
				strcat(buff, "\\");
			strcat(buff, "Redline.dll");

			if(GetModuleHandleA(buff))
			{

				VL("DllMain Process Detach Got handle");
				if(veriteInit && libraryLoaded && pVL_CloseVerite)
					pVL_CloseVerite(vhandle);

				VL("Got handle");
				
				//MessageBoxA(NULL, "Got module handle", "Test", MB_OK);
			}
			else
			{
				VL("DllMain Process Detach No handle");
				//MessageBoxA(NULL, "Did not get module handle", "Test", MB_OK);
			}*/
			}
			break;
    }
    return TRUE;
}


void LoadLibrary()
{
	DeleteFile("V2k.RReady.Redline.txt");
	InitializeCriticalSection(&oCS);

	if(!forceLogFlush)
	{
		log = fopen("V2k.RReady.Redline.txt", "w+");

		if(!log)
		{
			MessageBox(NULL, "Could not open log file", "V2k.RReady", MB_OK);
			exit(1);
		}
	}

	VLA("Started logging");

	/*{
		SYSTEMTIME st;
		GetLocalTime(&st);
		EnterCriticalSection(&oCS);

		fprintf(log, "%04d/%02d/%02d %02d:%02d:%02d.%03d Started logging\r\n", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);

		fflush(log);
	}*/



	char buff[MAX_PATH];
	GetSystemDirectory(buff, MAX_PATH);
	int len = strlen(buff);
	if(buff[len-1] != '\\')
		strcat(buff, "\\");
#ifdef RREADY
	strcat(buff, "Redline2.dll");
#else
	strcat(buff, "Redline.dll");
#endif
	sprintf(String, "Redline.dll redline path %s", buff);
	VL(String);
	HMODULE hLib = LoadLibrary(buff);
	if( hLib)
	{
		pVL_OpenVerite = (VL_OpenVeriteT)GetProcAddress(hLib, "VL_OpenVerite");

		pVL_CloseVerite = (VL_CloseVeriteT)GetProcAddress(hLib, "VL_CloseVerite");

		pVL_WaitForDisplaySwitch = (VL_WaitForDisplaySwitchT)GetProcAddress(hLib, "VL_WaitForDisplaySwitch");

		pVL_CreateSurface = (VL_CreateSurfaceT)GetProcAddress(hLib, "VL_CreateSurface");

		pVL_PointSurface = (VL_PointSurfaceT)GetProcAddress(hLib, "VL_PointSurface");

		pVL_DestroySurface = (VL_DestroySurfaceT) GetProcAddress(hLib, "VL_DestroySurface");

		pVL_SwapDisplaySurface = (VL_SwapDisplaySurfaceT) GetProcAddress(hLib, "VL_SwapDisplaySurface");

		pVL_FillBuffer= (VL_FillBufferT) GetProcAddress(hLib, "VL_FillBuffer");

		pVL_LoadBuffer = (VL_LoadBufferT) GetProcAddress(hLib, "VL_LoadBuffer");

		pVL_InstallDstBuffer = (VL_InstallDstBufferT) GetProcAddress(hLib, "VL_InstallDstBuffer");

		pVL_InstallTextureMap = (VL_InstallTextureMapT) GetProcAddress(hLib, "VL_InstallTextureMap");

		pVL_InstallZBuffer = (VL_InstallZBufferT) GetProcAddress(hLib, "VL_InstallZBuffer");

		pVL_SetSrcBase= (VL_Setvu32T) GetProcAddress(hLib, "VL_SetSrcBase");

		pVL_SetSrcFilter = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetSrcFilter");

		pVL_SetSrcFunc = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetSrcFunc");

		pVL_SetUMask = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetUMask");

		pVL_SetVMask = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetVMask");

		pVL_SetUMultiplier = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetUMultiplier");

		pVL_SetVMultiplier = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetVMultiplier");
		pVL_SetSrcStride = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetSrcStride");

		pVL_SetBlendSrcFunc = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetBlendSrcFunc");

		pVL_SetBlendDstFunc = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetBlendDstFunc");

		pVL_SetZBufMode = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetZBufMode");

		pVL_SetZBufWrMode = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetZBufWrMode");
		

		pVL_SetBlendEnable = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetBlendEnable");

		pVL_SetDitherEnable = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetDitherEnable");


		pVL_SetFogEnable = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetFogEnable");

		pVL_SetTranspReject = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetTranspReject");


		pVL_SetAlphaThreshold = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetAlphaThreshold");

		pVL_SetScissorX = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetScissorX");
		pVL_SetScissorY = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetScissorY");
		pVL_SetFGColorARGB = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetFGColorARGB");

		pVL_SetFogColorRGB = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetFogColorRGB");
		pVL_SetZ = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetZ");
		pVL_SetA = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetA");
		pVL_SetF = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetF");

		pVL_SetUClamp = (VL_SetClampT)GetProcAddress(hLib, "VL_SetUClamp");
		pVL_SetVClamp = (VL_SetClampT)GetProcAddress(hLib, "VL_SetVClamp");

		pVL_Rectangle = (VL_RectangleT)GetProcAddress(hLib, "VL_Rectangle");


		pVL_Triangle = (VL_TriangleT)GetProcAddress(hLib, "VL_Triangle");

		pVL_Tristrip = (VL_TristripT)GetProcAddress(hLib, "VL_Tristrip");
		pVL_Trifan = (VL_TristripT)GetProcAddress(hLib, "VL_Trifan");

		pVL_VertexSize = (VL_VertexSizeT)GetProcAddress(hLib, "VL_VertexSize");

		pVL_FrameMarker = (VL_FrameMarkerT)GetProcAddress(hLib, "VL_FrameMarker");
		
		libraryLoaded = (pVL_SetUClamp && pVL_SetVClamp &&
				pVL_OpenVerite&&
				pVL_CloseVerite&&
				pVL_WaitForDisplaySwitch&&
				pVL_CreateSurface&&
				pVL_PointSurface&&
				pVL_DestroySurface&&
				pVL_SwapDisplaySurface&&
				pVL_FillBuffer&&
				pVL_LoadBuffer&&
				pVL_InstallDstBuffer&&
				pVL_InstallTextureMap&&
				pVL_InstallZBuffer&&
				pVL_SetSrcBase&&
				pVL_SetSrcFilter&&
				pVL_SetSrcFunc &&
				pVL_SetUMask&&
				pVL_SetVMask&&
				pVL_SetUMultiplier&&
				pVL_SetVMultiplier&&
				pVL_SetSrcStride&&
				pVL_SetBlendSrcFunc&&
				pVL_SetBlendDstFunc&&
				pVL_SetZBufMode&&
				pVL_SetZBufWrMode&&
				pVL_SetBlendEnable&&
				pVL_SetDitherEnable&&
				pVL_SetFogEnable&&
				pVL_SetTranspReject&&
				pVL_SetAlphaThreshold&&
				pVL_SetScissorX&&
				pVL_SetScissorY&&
				pVL_SetFGColorARGB&&
				pVL_SetFogColorRGB&&
				pVL_SetZ&&
				pVL_SetA&&
				pVL_SetF&&
				pVL_Rectangle&&
				pVL_Triangle&&
				pVL_Tristrip&&
				pVL_Trifan&&
				pVL_VertexSize&&
				pVL_FrameMarker);
		if(!libraryLoaded)
		{
			VL("Failed to load library (Redline.DLL)");
			MessageBoxA(NULL, "Could not load library function", "Redline.dll", MB_OK);
			exit(1);
		}
		VL("Redline loaded system\\redline.DLL library");
		
	}
	else
	{
		VL("Failed to load system\\Redline.dll library");
		MessageBoxA(NULL, "LoadLibrary failed (system) Redline.dll", buff, MB_OK);
		exit(1);
	}

	{
		//GetSystemDirectory(buff, MAX_PATH);
		GetModuleFileNameA(NULL, buff, MAX_PATH);
		//int len = strlen(buff);
		//if(buff[len-1] != '\\')
			//strcat(buff, "\\");
		char *ptr = strrchr(buff, '\\');

		*(ptr+1) = 0;
		

		strcat(buff, "Verite.dll");


		sprintf(String, "Redline.dll local verite path %s", buff);
		VL(String);

		HMODULE hLibVerite = LoadLibrary(buff);


		//pV_GetBufferStride = (V_GetBufferStrideType)GetProcAddress(hLibVerite, "V_GetBufferStride");
		pV_GetBufferStride = (V_GetBufferStrideType)GetProcAddress(hLibVerite, "V_GetBufferLinebytes");
		
		pV_AddToCmdList = (V_AddToCmdListType)GetProcAddress(hLibVerite, "V_AddToCmdList");

		pV_GetBufferAddress = (V_GetBufferAddressT)GetProcAddress(hLibVerite, "V_GetBufferAddress");

		if(!(pV_AddToCmdList&&pV_GetBufferStride&& pV_GetBufferAddress))
		{
			VL("Failed to load system\\Verite.dll library");
			MessageBoxA(NULL, "LoadLibrary failed (system) Verite.dll", buff, MB_OK);
		}
		else
		{
			VL("Redline.dll successfully load system\\Verite.dll library");
		}
	}

#ifdef INDIRECTSRC
	VL("With IndirectSRC");
#else
	VL("No IndirectSRC");
#endif


	//VL_OpenVerite = 
}


__declspec(naked) __declspec(dllexport) vl_error VL_OpenVerite_()
{
	
	//VLLOG("VL_OpenVerite_");
	//ELOG(std::format("VL_OpenVerite__ entry HWND {:08X}, microcode filename \"{}\"", (size_t)hwnd, microcode ? std::string(microcode) : std::string("")));
	//unsigned int *v13;
	//int Redx;
	__asm {
		//push    ebx;
		//push    ecx;
		//push    esi;
		//push    edi;
		pushad;
		mov hwnd, eax;
		//mov v13, esp;
		//mov Redx, edx;
		mov pVhandle, edx;
	}
	//VLA("VL_OpenVerite_()");
	//std::vector<char> temp(256);
	//sprintf_s(temp.data(), temp.size(), "v%-4x3d.uc", *v13);
	//ELOG(std::format("HWND {:08X}, Microcode file is {}, EDX {:08X}, vhandle * {:08X}", (size_t)hwnd, temp.data(), Redx, (size_t)vhandle));
	//ELOG(std::format("v13 is {}", *v13));
	{
	if(!libraryLoaded)
		LoadLibrary();

#ifdef TEST	
	VLA("VL_OpenVerite_");
	if(!pVL_OpenVerite)
		Error("pVL_OpenVerite");
#endif
	}

	e = pVL_OpenVerite(hwnd, pVhandle);
	//if( e == VL_SUCCESS)
	veriteInit = true;
	//sprintf(tempBuff, "vhandle %08X, HWND %08X", (size_t)vhandle, (size_t)hwnd);
	//VL(tempBuff);
	//ELOG(std::format("vhandle * {:08X}, *vhandle* {:08X}", (size_t)vhandle, (size_t)*vhandle));
	//return e;
	__asm {
		popad;
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
		//add esp, 0Ch;
	}
}

__declspec(naked) __declspec(dllexport) vl_error VL_CloseVerite_()
{

	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		pushad;
	}


	__asm {
		mov vhandle, eax;
	}
#ifdef TEST
	{
	VLA("VL_CloseVerite_");
	//VLA("VL_CloseVerite_");
	if(!pVL_CloseVerite)
		Error("pVL_CloseVerite");
	}
#endif

	e = pVL_CloseVerite(vhandle);

	__asm {
		popad;
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_WaitForDisplaySwitch_()
{
	//v_cmdbuffer* cmdbuffer;
	__asm {
		//mov eax, VL_SUCCESS;
		//ret;
//#ifdef PUSHPOP
		pushad;
//#endif
		mov cmdbuffer, eax;
	
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
	}
#ifdef TEST
	{
	VLA("VL_WaitForDisplaySwitch_");
	//vl_error e;
	if(!pVL_WaitForDisplaySwitch)
		Error("pVL_WaitForDisplaySwitch");
	}
#endif

	e =  pVL_WaitForDisplaySwitch(cmdbuffer);
	__asm {
//#ifdef PUSHPOP
		popad;
//#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error V_DLLIMPORT VL_CreateSurface_()
{
#ifdef PUSHPOP
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		pushad

	}


	__asm {
		/*mov vhandle, eax;
		mov psurface, edx;
		mov buffer_mask, ebx;
		mov num_buffers, ecx;
		

		mov eax, esp;
		mov ebx, [eax + 20];
		mov pixel_fmt, ebx;
		mov ebx, [eax + 24];
		mov width, ebx;
		mov ebx, [eax + 28];
		mov height, ebx;*/
		mov vhandle, eax;
		mov psurface, edx;
		mov buffer_mask, ebx;
		mov num_buffers, ecx;
		

		mov eax, esp;
		mov ebx, [eax + 36];
		//mov ebx, [eax + 28];
		//mov ebx, [eax + 20];
		mov pixel_fmt, ebx;
		mov ebx, [eax + 40];
		//mov ebx, [eax + 32];
		//mov ebx, [eax + 24];
		mov width, ebx;
		mov ebx, [eax + 44];
		//mov ebx, [eax + 36];
		//mov ebx, [eax + 28];
		mov height, ebx;

	}
#else
	__asm {
		/*mov vhandle, eax;
		mov psurface, edx;
		mov buffer_mask, ebx;
		mov num_buffers, ecx;
		

		mov eax, esp;
		mov ebx, [eax + 20];
		mov pixel_fmt, ebx;
		mov ebx, [eax + 24];
		mov width, ebx;
		mov ebx, [eax + 28];
		mov height, ebx;*/
		mov vhandle, eax;
		mov psurface, edx;
		mov buffer_mask, ebx;
		mov num_buffers, ecx;
		

		mov eax, esp;
		mov ebx, [eax + 4];
		//mov ebx, [eax + 28];
		//mov ebx, [eax + 20];
		mov pixel_fmt, ebx;
		mov ebx, [eax + 8];
		//mov ebx, [eax + 32];
		//mov ebx, [eax + 24];
		mov width, ebx;
		mov ebx, [eax + 12];
		//mov ebx, [eax + 36];
		//mov ebx, [eax + 28];
		mov height, ebx;

	}
#endif
	/*sprintf_s(tempBuff, 1024, "VL_CreateSurface_ vhandle %08X, psurface %08X, mask %d, pixel_fmt %d, %dx%d", (size_t)vhandle, (size_t)psurface,
		buffer_mask, pixel_fmt, width, height);
	VL(tempBuff);*/
	{
#ifdef TEST
	VLA("VL_CreateSurface_");
	if(!pVL_CreateSurface)
		Error("pVL_CreateSurface");
#endif
#ifdef TEST
	{
			/*if(surface->pixel_fmt == V_PIXFMT_4I_565 ||
				surface->pixel_fmt == V_PIXFMT_4I_4444||
				surface->pixel_fmt == V_PIXFMT_4I_1555)*/
			{
				bool paletted =(pixel_fmt == V_PIXFMT_4I_565 ||
				pixel_fmt == V_PIXFMT_4I_4444||
				pixel_fmt == V_PIXFMT_4I_1555);
				//v_u32 stride = pV_GetBufferStride(surface->buffer_group, 0);

				sprintf(String, "VL_CreateSurface %s surf dims %ux%u, buffer_mask %u, pixel_fmt %u, num_buffers %u",
					paletted?"(Paletted)":"", width, height, buffer_mask, pixel_fmt, num_buffers );
				//if( 

				VLA(String);

				
			}
	}
#endif

	}
	
	e =  pVL_CreateSurface(vhandle,
		psurface,
		buffer_mask,
		num_buffers,
		pixel_fmt,
		width,
		height);
#ifdef TEST
	{
		v_u32 stride = pV_GetBufferStride((*psurface)->buffer_group, 0);
		sprintf(String, "Stride is %u", stride);
		VLA(String);
	}
#endif
	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret 4 * 3;
	}
}


__declspec(naked) __declspec(dllexport) vl_error V_DLLIMPORT VL_DestroySurface_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif
	}


	__asm {
		mov vhandle, eax;
		mov surface, edx;
	}
	{
#ifdef TEST
	VLA("VL_DestroySurface_");
	//sprintf_s(tempBuff, 1024, "VL_DestroySurface_ vhandle %08X, surface %08X", (size_t)vhandle, (size_t)surface);
	//VL(tempBuff);
	if(!pVL_DestroySurface)
		Error("pVL_DestroySurface");
#endif
	}
	e = pVL_DestroySurface(vhandle, surface);
	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SwapDisplaySurface_()
{
	//v_cmdbuffer* cmdbuffer;
	//v_surface* surface;

	__asm {
		mov cmdbuffer, eax;
		mov surface, edx;
#ifdef PUSHPOP
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
#endif
	}
#ifdef TEST
	{
	if(!surface)
		VLA("VL_SwapDisplaySurface Surface is nullptr");
	else
	{
		sprintf(String, "VL_SwapDisplaySurface mask %u, buffer count %u, fmt %u, dims %ux%u",
			surface->buffer_mask, surface->num_buffers,
			surface->pixel_fmt, surface->width, surface->height);
		VLA(String);
	}

	//VLA("VL_SwapDisplaySurface_");
	if(!pVL_SwapDisplaySurface)
		Error("pVL_SwapDisplaySurface");
	}
#endif
	{
	//VLA("VL_SwapDisplaySurface_");
		e = pVL_SwapDisplaySurface(cmdbuffer, surface);
		//if(pVL_WaitForDisplaySwitch)
		//	pVL_WaitForDisplaySwitch(cmdbuffer);
	}

	__asm {
		mov eax, e;
#ifdef PUSHPOP
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
#endif
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_FillBuffer_()
{
	__asm {

		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		pushad;
	}



	__asm {

		/*mov cmdbuffer, eax;
		mov surface, edx;
		mov buffer, ebx;

		mov ebx, esp;
		mov ecx, [esp + 20];
		mov pixel_value, ecx;
		mov ecx, [esp + 24];
		mov width, ecx;
		mov ecx, [esp + 28];
		mov height, ecx;
		mov ecx, [esp + 32];
		mov xorg, ecx;
		//mov ecx, [esp + 36];
		//mov yorg, ecx;*/
		mov cmdbuffer, eax;
		mov surface, edx;
		mov buffer, ebx;

		mov ebx, esp;
		mov ecx, [esp + 36];
		//mov ecx, [esp + 28];
		//mov ecx, [esp + 20];
		mov pixel_value, ecx;
		mov ecx, [esp + 40];
		//mov ecx, [esp + 32];
		//mov ecx, [esp + 24];
		mov width, ecx;
		mov ecx, [esp + 44];
		//mov ecx, [esp + 36];
		//mov ecx, [esp + 28];
		mov height, ecx;
		mov ecx, [esp + 48];
		//mov ecx, [esp + 40];
		//mov ecx, [esp + 32];
		mov xorg, ecx;

	}
	yorg = xorg & 0xFFFF;
	xorg >>= 16;

#ifdef TEST
	{
	//VLA("VL_FillBuffer_");
		if(!surface)
			VL("VL_FillBuffer surface is nullptr");
		else
		{
			sprintf(String, "VL_FillBuffer_ cmdbuffer %08X, surface %08X, buffer %d,  (%d,%d)-(%d, %d), pixel %08X, surface fmt %u dims%ux%u",
			(size_t)cmdbuffer, (size_t)surface, buffer, xorg, yorg, width, height, pixel_value, surface->pixel_fmt, surface->width, surface->height);
			VLA(String);
		}
	if(!pVL_FillBuffer)
		Error("pVL_FillBuffer");
	}
#endif

	e =  pVL_FillBuffer(cmdbuffer,
		surface,
		buffer,
		xorg,
		yorg,
		width,
		height,
		pixel_value);

	__asm {

		popad;

		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret 4 * 4;
		//ret;
	}

}


__declspec(naked)  __declspec(dllexport) vl_error V_DLLIMPORT VL_LoadBuffer_()
{

#ifdef PUSHPOP
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		pushad;
	}


	__asm {
		/*mov cmdbuffer, eax;
		mov surface, edx;
		mov data_linebytes, ecx;
		mov buffer, ebx;


		mov eax, esp;

		mov ebx, [eax + 32];
		mov data_addr, ebx;
		mov ebx, [eax + 28];
		mov memory, ebx;
		mov ebx, [eax + 24];
		mov data_height, ebx;
		mov ebx, [eax + 20];
		mov data_width, ebx;*/

		mov cmdbuffer, eax;
		mov surface, edx;
		mov data_linebytes, ecx;
		mov buffer, ebx;


		mov eax, esp;

		mov ebx, [eax + 48];
		//mov ebx, [eax + 40];
		//mov ebx, [eax + 32];
		mov data_addr, ebx;
		mov ebx, [eax + 44];
		//mov ebx, [eax + 36];
		//mov ebx, [eax + 28];
		mov memory, ebx;
		mov ebx, [eax + 40];
		//mov ebx, [eax + 32];
		//mov ebx, [eax + 24];
		mov data_height, ebx;
		mov ebx, [eax + 36];
		//mov ebx, [eax + 28];
		//mov ebx, [eax + 20];
		mov data_width, ebx;


	}
#else
	__asm {
		/*mov cmdbuffer, eax;
		mov surface, edx;
		mov data_linebytes, ecx;
		mov buffer, ebx;


		mov eax, esp;

		mov ebx, [eax + 32];
		mov data_addr, ebx;
		mov ebx, [eax + 28];
		mov memory, ebx;
		mov ebx, [eax + 24];
		mov data_height, ebx;
		mov ebx, [eax + 20];
		mov data_width, ebx;*/

		mov cmdbuffer, eax;
		mov surface, edx;
		mov data_linebytes, ecx;
		mov buffer, ebx;


		mov eax, esp;

		mov ebx, [eax + 16];
		//mov ebx, [eax + 40];
		//mov ebx, [eax + 32];
		mov data_addr, ebx;
		mov ebx, [eax + 12];
		//mov ebx, [eax + 36];
		//mov ebx, [eax + 28];
		mov memory, ebx;
		mov ebx, [eax + 8];
		//mov ebx, [eax + 32];
		//mov ebx, [eax + 24];
		mov data_height, ebx;
		mov ebx, [eax + 4];
		//mov ebx, [eax + 28];
		//mov ebx, [eax + 20];
		mov data_width, ebx;


	}
#endif
	/*if (cmdbuffer)
	{
		sprintf_s(tempBuff, 1024, "VL_LoadBuffer_ cmdbuffer %08X (%d), vsurf %08X, dims %ux%u, linebytes %u, memory %08X, address %08X",
			(size_t)cmdbuffer, (*cmdbuffer)->id, (size_t)surface, data_width, data_height, data_linebytes, (size_t)memory, (size_t)data_addr);
	}
	else
	{
		sprintf_s(tempBuff, 1024, "VL_LoadBuffer_ cmdbuffer %08X, vsurf %08X, dims %ux%u, linebytes %u, memory %08X, address %08X",
			(size_t)cmdbuffer, (size_t)surface, data_width, data_height, data_linebytes, (size_t)memory, (size_t)data_addr);
	}
	VL(tempBuff);
	if (surface)
	{
		if (surface->buffer_mask != 3)
			VLA("VL_LoadBuffer_ Not primary surface");
		sprintf_s(tempBuff, 1024, "vsurface %ux%u, format %u, mask %u, num buffers %u", surface->width, surface->height,
			surface->pixel_fmt, surface->buffer_mask, surface->num_buffers);
		VL(tempBuff);
	}
	{
	//VLA("VL_LoadBuffer_");
	if(!pVL_LoadBuffer)
		Error("pVL_LoadBuffer");

	}*/
#ifdef TEST
	{
		noFlush = true;
			if(surface->pixel_fmt == V_PIXFMT_4I_565 ||
				surface->pixel_fmt == V_PIXFMT_4I_4444||
				surface->pixel_fmt == V_PIXFMT_4I_1555)
			{
				v_u32 stride = pV_GetBufferStride(surface->buffer_group, 0);
				v_u32 targetWidth = stride <<1;
				//if(targetWidth != 
				sprintf(String, "VL_LoadBuffer (Paletted) surf dims %ux%u, stride %u, stride width %u, linebytes %u, load dims %ux%u",
					surface->width, surface->height, stride, targetWidth, data_linebytes, data_width, data_height);
				//if( 
				//data_linebytes = stride;
				//data_width = targetWidth;
				VLA(String);
				//e = VL_SUCCCESS;
			}
			/*else
			{
				v_u32 stride = pV_GetBufferStride(surface->buffer_group, 0);
				v_u32 targetWidth = stride <<1;
				//if(targetWidth != 
				sprintf(String, "VL_LoadBuffer (Paletted) surf dims %ux%u, stride %u, stride width %u, linebytes %u, load dims %ux%u",
					surface->width, surface->height, stride, targetWidth, data_linebytes, data_width, data_height);
				//if( 
				//data_linebytes = stride;
				//data_width = targetWidth;
				VLA(String);
			}*/
	}
#endif

	e = pVL_LoadBuffer(cmdbuffer,
		surface,
		buffer,
		data_linebytes,
		data_width,
		data_height,
		memory, data_addr);
	{
		noFlush = false;
	}
	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret 4 * 4;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_InstallDstBuffer_()
{
	

	__asm {
		mov cmdbuffer, eax;
		mov surface, edx;
#ifdef PUSHPOP
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
#endif
	}
	//sprintf_s(tempBuff, 1024, "VL_InstallDstBuffer_ cmdbuffer %08X, v_surface %08X", (size_t)cmdbuffer, (size_t)surface);
	//VL(tempBuff);
	//vl_error e;
#ifdef TEST
	{
	VLA("VL_InstallDstBuffer_");

	if(!pVL_InstallDstBuffer)
		Error("pVL_InstallDstBuffer");
	}
#endif

	
	e = pVL_InstallDstBuffer(cmdbuffer, surface);
	__asm {
		mov eax, e;
#ifdef PUSHPOP
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
#endif
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_InstallTextureMap_()
{
	__asm {
		mov surface, edx;
		mov cmdbuffer, eax;
#ifdef PUSHPOP
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
#endif
	}
	//sprintf_s(tempBuff, 1024, "VL_InstallTextureMap_ cmdbuffer %08X, surface %08X", (size_t)cmdbuffer, (size_t)surface);
	//VL(tempBuff);
	////vl_error e;
	//e = VL_InstallZBuffer(cmdbuffer, surface);

	//VLA("VL_InstallTextureMap_");
#ifdef TEST
	{
		noFlush = true;
		PIXELFORMAT = surface->pixel_fmt;
	VLA("VL_InstallTextureMap_");
	if(!pVL_InstallTextureMap)
		Error("pVL_InstallTextureMap");
	/*if(surface->pixel_fmt == V_PIXFMT_4I_565 ||
		surface->pixel_fmt == V_PIXFMT_4I_4444||
		surface->pixel_fmt == V_PIXFMT_4I_1555)
		VLA("Paletted texture map");
		
*/
		SRCBASE = (v_u32)pV_GetBufferAddress(surface->buffer_group, 0);
		
			if(surface->pixel_fmt == V_PIXFMT_4I_565 ||
				surface->pixel_fmt == V_PIXFMT_4I_4444||
				surface->pixel_fmt == V_PIXFMT_4I_1555)
			{
 				v_u32 stride = pV_GetBufferStride(surface->buffer_group, 0);
				sprintf(String, "Paletted textures dims %ux%u, stride %u", surface->width, surface->height, stride);
				VLD(String);
				//if((stride<<1) != surface->width)
				/*{
					surface->width = (stride<<1);
					sprintf(String, "Resizing: new width is %u", surface->width);
					VLA(String);
					//pVL_SetSrcStride(cmdbuffer, (stride+1)>>1);
				}*/
				//VLA("Paletted texture map");
				//e = VL_SUCCESS;
			}
			else
			{
				v_u32 stride = pV_GetBufferStride(surface->buffer_group, 0);
				sprintf(String, "Regular textures dims %ux%u, stride %u", surface->width, surface->height, stride);
				VLD(String);
				//e = pVL_InstallTextureMap(cmdbuffer, surface);

			}

	}
#endif


		e = pVL_InstallTextureMap(cmdbuffer, surface);
		{
			noFlush = false;
			/*if(surface->pixel_fmt == V_PIXFMT_4I_565 ||
				surface->pixel_fmt == V_PIXFMT_4I_4444||
				surface->pixel_fmt == V_PIXFMT_4I_1555)
			{
 				v_u32 stride = pV_GetBufferStride(surface->buffer_group, 0);
				sprintf(String, "Paletted textures dims %ux%u, stride %u", surface->width, surface->height, stride);
				VLA(String);
				if(stride >= surface->width)
				{
					VLA("Shrinking stride down to roughly half");
					pVL_SetSrcStride(cmdbuffer, (stride+1)>>1);
				}
				//VLA("Paletted texture map");
			}*/
		}
	//else 
	//	e = VL_SUCCESS;

	//srcFormat = surface->pixel_fmt;

	__asm {
		mov eax, e;
#ifdef PUSHPOP
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
#endif
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_InstallZBuffer_()
{
	//v_cmdbuffer* cmdbuffer;
	//v_surface* surface;
	__asm {
		mov surface, edx;
		mov cmdbuffer, eax;
#ifdef PUSHPOP
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
#endif
	}
	//sprintf_s(tempBuff, 1024, "VL_InstallZBuffer_ cmdbuffer %08X, surface %08X", (size_t)cmdbuffer, (size_t)surface);
	//VL(tempBuff);
	//vl_error e;
#ifdef TEST
	{
	if(!pVL_InstallZBuffer)
		Error("pVL_InstallZBuffer");
	}
#endif

	e = pVL_InstallZBuffer(cmdbuffer, surface);
	__asm {
		mov eax, e;
#ifdef PUSHPOP
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
#endif
		ret;
	}
}

__declspec(naked) __declspec(dllexport) vl_error VL_SetSrcBase_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif

		mov cmdbuffer, eax;
		mov SRCBASE, edx;
	}
#ifdef TEST
	{
		sprintf(String, "VL_SetSrcBase_ %08X", SRCBASE);
		VLD(String);
	VLL("VL_SetSrcBase_");
	if(!pVL_SetSrcBase)
		Error("pVL_SetSrcBase");
	}
#endif

	e = pVL_SetSrcBase(cmdbuffer, SRCBASE);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetSrcFunc_()
{


	__asm {
#ifdef PUSHPOP
		pushad;
#endif
		mov src_func, edx;
		mov cmdbuffer, eax;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		
	}
#ifdef TEST
	{
	//VLL("VL_SetSrcFunc_");
	sprintf(String, "VL_SetSrcFunc_ %d", src_func);
	VLA(String);

	if(!pVL_SetSrcFunc)
		Error("pVL_SetSrcFunc");
	}
#endif

	e = pVL_SetSrcFunc(cmdbuffer, src_func);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}



__declspec(naked) __declspec(dllexport) vl_error VL_SetSrcFilter_()
{
	__asm {
#ifdef PUSHPOP
		pushad;
#endif
		mov src_filter, edx;
		mov cmdbuffer, eax;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		
	}
	//sprintf_s(tempBuff, 1024, "VL_SetSrcFilter_ %u", src_filter);
	//VL(tempBuff);
#ifdef TEST
	{
	VLL("VL_SetSrcFilter_");
	if(!pVL_SetSrcFilter)
		Error("pVL_SetSrcFilter");
	}
#endif

	e = pVL_SetSrcFilter(cmdbuffer, src_filter);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetUMask_()
{
	__asm {
#ifdef PUSHPOP
		pushad;
#endif
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/

		mov cmdbuffer, eax;
		mov UMASK, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetUMask_ %u", u_mult);
	//VL(tempBuff);
#ifdef TEST
	{
	VLL("VL_SetUMask_");
	if(!pVL_SetUMask)
		Error("pVL_SetUMask");
	}
#endif

	e = pVL_SetUMask(cmdbuffer, UMASK);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetVMask_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif

		mov cmdbuffer, eax;
		mov VMASK, edx;
	}
#ifdef TEST
	//sprintf_s(tempBuff, 1024, "VL_SetVMask_ %u", u_mult);
	//VL(tempBuff);
	{
	VLL("VL_SetVMask_");
	if(!pVL_SetVMask)
		Error("pVL_SetVMask");
	}
#endif

	e = pVL_SetVMask(cmdbuffer, VMASK);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetUMultiplier_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif

		mov cmdbuffer, eax;
		mov UMULT, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetUMultiplier_ %u %f", UMULT, UMULT/65536.0f);
	//VL(tempBuff);
#ifdef TEST
	{
	VLL("VL_SetUMultiplier_");
	if(!pVL_SetUMultiplier)
		Error("pVL_SetUMultiplier");
	}
#endif

	e = pVL_SetUMultiplier(cmdbuffer, UMULT);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetVMultiplier_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif

		mov cmdbuffer, eax;
		mov VMULT, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetVMultiplier_ %u, %f", VMULT, VMULT / 65536.0);
	//VL(tempBuff);
#ifdef TEST
	{
	VLL("VL_SetVMultiplier_");
	if(!pVL_SetVMultiplier)
		Error("pVL_SetVMultiplier");
	}
#endif

	e = pVL_SetVMultiplier(cmdbuffer, VMULT);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}

/*bool HasPalette(v_u32 pixel_fmt)
{
	return (pixel_fmt == V_PIXFMT_4I_565 ||
		pixel_fmt == V_PIXFMT_4I_4444||
		pixel_fmt == V_PIXFMT_4I_1555);
}*/



__declspec(naked) __declspec(dllexport) vl_error VL_SetSrcStride_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif

		mov cmdbuffer, eax;
		mov u_mult, edx;
		//mov lastSrcStride, edx;
	}
#ifdef TEST
	{
		sprintf(String, "VL_SetSrcStride_ %u", u_mult);
		VLD(String);
	}
#endif
#ifdef TEST
	{
	VLL("VL_SetSrcStride_");
	if(!pVL_SetSrcStride)
		Error("pVL_SetSrcStride");
	}
#endif

	//srcStride = HasPalette(srcFormat)?((u_mult+1)>>1):u_mult;

	e = pVL_SetSrcStride(cmdbuffer, u_mult);
	//srcStride = u_mult;

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetBlendSrcFunc_()
{
	

	__asm {
#ifdef PUSHPOP
		pushad;
#endif
		mov blend_src_func, edx;
		mov cmdbuffer, eax;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		
	}
#ifdef TEST
	{
	//VLL("VL_SetBlendSrcFunc_");
	sprintf(String, "VL_SetBlendSrcFunc_ %d", blend_src_func);
	VLA(String);

	if(!pVL_SetBlendSrcFunc)
		Error("pVL_SetBlendSrcFunc");
	}
#endif
	
	e = pVL_SetBlendSrcFunc(cmdbuffer, blend_src_func);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetBlendDstFunc_()
{
	__asm {
#ifdef PUSHPOP
		pushad;
#endif
		mov blend_dst_func, edx;
		mov cmdbuffer, eax;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
	}
#ifdef TEST
	{
	sprintf(String, "VL_SetBlendDstFunc_ %d", blend_dst_func);
	VLA(String);

	//VLL("VL_SetBlendDstFunc_");
	if(!pVL_SetBlendDstFunc)
		Error("pVL_SetBlendDstFunc");
	}
#endif

	e =  pVL_SetBlendDstFunc(cmdbuffer, blend_dst_func);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}



__declspec(naked) __declspec(dllexport) vl_error VL_SetZBufMode_()
{
		
	__asm {
#ifdef PUSHPOP
		pushad;
#endif
		mov z_buf_mode, edx;
		mov cmdbuffer, eax;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
	}
#ifdef TEST
	{
	//VLL("VL_SetBlendZBufMode_");
	//VLL("VL_SetZBufMode_");
	sprintf(String, "VL_SetZBufMode_ cmdbuffer %08X,  mode  %d", (size_t) cmdbuffer, z_buf_mode);
	VLA(String);

	//sprintf_s(tempBuff, 1024, "VL_SetZBufMode_ cmdbuffer %08X,  mode  %d", (size_t) cmdbuffer, z_buf_mode);
	//VL(tempBuff);
	//vl_error e;
	if(!pVL_SetZBufMode)
		Error("pVL_SetZBufMode");
	}
#endif

	e = pVL_SetZBufMode(cmdbuffer, z_buf_mode);
	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetZBufWrMode_()
{
	//v_cmdbuffer* cmdbuffer;
	

	__asm {
#ifdef PUSHPOP
		pushad;
#endif
		mov z_buf_wr_mode, edx;
		mov cmdbuffer, eax;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		
	}
	//sprintf_s(tempBuff, 1024, "VL_SetZBufWrMode_ cmdbuffer %08X, write mode %d", (size_t)cmdbuffer, z_buf_wr_mode);
	//VL(tempBuff);
#ifdef TEST
	{
	//VLL("VL_SetZBufWrMode_");
	sprintf(String, "VL_SetZBufWrMode_ cmdbuffer %08X, write mode %d", (size_t)cmdbuffer, z_buf_wr_mode);
	VLA(String);

	if(!pVL_SetZBufWrMode)
		Error("pVL_SetZBufWrMode");
	}
#endif

	e = pVL_SetZBufWrMode(cmdbuffer, z_buf_wr_mode);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) vl_error __declspec(dllexport) VL_SetBlendEnable_()
{

	__asm {
#ifdef PUSHPOP
		pushad;
#endif
		mov blend_enable, edx;
		mov cmdbuffer, eax;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		
	}
#ifdef TEST
	{
	VLL("VL_SetBlendEnable_");
	sprintf(String, "VL_SetBlendEnable_ %d", blend_enable);
	VLA(String);
	if(!pVL_SetBlendEnable)
		Error("pVL_SetBlendEnable");
	}
#endif

	e = pVL_SetBlendEnable(cmdbuffer, blend_enable);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetDitherEnable_()
{

	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif

		mov cmdbuffer, eax;
		mov dither_enable, edx;

	}
#ifdef TEST
	{
		VLL("VL_SetDitherEnable_");

		//vl_error e;
		if(!pVL_SetDitherEnable)
			Error("pVL_SetDitherEnable");
		/*if (!clamped)
		{
			pVL_SetUClamp(cmdbuffer, V_UCLAMP_ENABLE);
			pVL_SetVClamp(cmdbuffer, V_VCLAMP_ENABLE);
			clamped = true;
		}*/
	}
#endif

	e = pVL_SetDitherEnable(cmdbuffer, dither_enable);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetFogEnable_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif
		mov cmdbuffer, eax;
		mov fog_enable, edx;
	}
#ifdef TEST
	{
		//VLL("VL_SetFogEnable_");
		sprintf(String, "VL_SetFogEnable_ %u", fog_enable);
		VLA(String);

	if(!pVL_SetFogEnable)
		Error("pVL_SetFogEnable");
	}
#endif

	e = pVL_SetFogEnable(cmdbuffer, fog_enable);
	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetTranspReject_()
{

	__asm {
#ifdef PUSHPOP
		pushad;
#endif
		mov transp_reject, edx;
		mov cmdbuffer, eax;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		
	}
#ifdef TEST
	{
	VLL("VL_SetTranspReject_");
	sprintf(String, "VL_SetTranspReject_ %d", transp_reject);
	VLA(String);
	if(!pVL_SetTranspReject)
		Error("pVL_SetTranspReject");
	}
#endif

	e = pVL_SetTranspReject(cmdbuffer, transp_reject);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) vl_error __declspec(dllexport) VL_SetAlphaThreshold_()
{
	

	__asm {
#ifdef PUSHPOP
		pushad;
#endif
		mov alpha_threshold, edx;
		mov cmdbuffer, eax;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		
	}

	//sprintf_s(tempBuff, 1024, "VL_SetAlphaThreshold_ %d", alpha_threshold);
	//VL(tempBuff);
#ifdef TEST
	{
	//VLL("VL_SetAlphaThreshold_");
	sprintf(String, "VL_SetAlphaThreshold_ %d", alpha_threshold);
	VLA(String);

	if(!pVL_SetAlphaThreshold)
		Error("pVL_SetAlphaThreshold");
	}
#endif

	e =  pVL_SetAlphaThreshold(cmdbuffer, (v_u8)alpha_threshold);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetScissorX_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif
		mov cmdbuffer, eax;
		//mov v13, esp;
		//mov Redx, edx;
		mov v_type, edx;
	}
#ifdef TEST
	{
	VLL("VL_SetScissorX_");
	//sprintf_s(tempBuff, 1024, "VL_SetScissorX_ cmdbuffer %08X, scissor X %08X", (size_t)cmdbuffer, v_type);
	//VL(tempBuff);
	if(!pVL_SetScissorX)
		Error("pVL_SetScissorX");
	}
#endif


	e = pVL_SetScissorX(cmdbuffer, v_type);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
		//add esp, 0Ch;
	}

}

__declspec(naked) __declspec(dllexport) vl_error VL_SetScissorY_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif
		mov cmdbuffer, eax;
		//mov v13, esp;
		//mov Redx, edx;
		mov v_type, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetScissorY_ cmdbuffer %08X, scissor X %08X", (size_t)cmdbuffer, v_type);
	//VL(tempBuff);
#ifdef TEST
	{
	VLL("VL_SetScissorY_");
	if(!pVL_SetScissorY)
		Error("pVL_SetScissorY");
	}
#endif


	e = pVL_SetScissorY(cmdbuffer, v_type);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
		//add esp, 0Ch;
	}

	//VLLOG("VL_SetScissorY_");
	//return VL_SetScissorY(cmdbuffer, scissor_y);
}



__declspec(naked) __declspec(dllexport) vl_error VL_SetFGColorARGB_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif
	}


	__asm {
		mov cmdbuffer, eax;
		mov fg_color, edx;
	}
#ifdef TEST
	{
	//VLL("VL_SetFGColourARGB_");
	sprintf(String, "VL_SetFGColorARGB_ %08X", fg_color);
	VLL(String);
	if(!pVL_SetFGColorARGB)
		Error("pVL_SetFGColorARGB");
	}
#endif
	e = pVL_SetFGColorARGB(cmdbuffer, fg_color);
	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetFogColorRGB_()
{
	__asm	{
#ifdef PUSHPOP
		pushad;
#endif
		mov fog_color, edx;
		mov cmdbuffer, eax;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		

	}
	//sprintf_s(tempBuff, 1024, "VL_SetFogColorRGB_ %08X", fog_color);
	//VL(tempBuff);
#ifdef TEST
	{
	VLL("VL_SetFogColourRGB_");
	if(!pVL_SetFogColorRGB)
		Error("pVL_SetFogColorRGB");
	}
#endif
	e = pVL_SetFogColorRGB(cmdbuffer, fog_color);
	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error V_DLLIMPORT VL_SetZ_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetZ_ %u", u_mult);
	//VL(tempBuff);'
#ifdef TEST
	{
	VLL("VL_SetZ_");
	if(!pVL_SetZ)
		Error("pVL_SetZ");
	}
#endif

	e = pVL_SetZ(cmdbuffer, u_mult);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetA_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetA_ %u", u_mult);
	//VL(tempBuff);
#ifdef TEST
	{
	VLL("VL_SetA_");
	if(!pVL_SetA)
		Error("pVL_SetA");
	}
#endif

	e = pVL_SetA(cmdbuffer, u_mult);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetF_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/

		pushad;


		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetF_ %u", u_mult);
	//VL(tempBuff);
#ifdef TEST
	{
	//VLL("VL_SetF_");
	sprintf(String, "VL_SetF_ %u", u_mult);
	VLL(String);
	if(!pVL_SetF)
		Error("pVL_SetF");
	}
#endif
	//e = VL_SUCCESS;
	e = pVL_SetF(cmdbuffer, u_mult);

	__asm {

		popad;

		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_Rectangle_()
{
//#ifdef PUSHPOP
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov v_type, edx;
		mov width, ebx;
		mov height, ecx;
		mov eax, esp
		mov ebx, [eax + 20];
		mov vert, ebx;*/
		pushad;

		mov cmdbuffer, eax;
		mov v_type, edx;
		mov width, ebx;
		mov height, ecx;
		mov eax, esp
		mov ebx, [eax + 36];
		//mov ebx, [eax + 28];
		//mov ebx, [eax + 20];
		mov vert, ebx;

	}
	//height >>= 16;
	//width >>= 16;
	//sprintf_s(tempBuff, 1024, "VL_Rectangle_ vtype %u, %ux%u, vert %08X", v_type, width>>16, height>>16, (size_t) vert);
#ifdef TEST
	{
	//VLL("VL_Rectangle_");
	////height >>= 16;
	////width >>= 16;
	sprintf(String, "VL_Rectangle_ vtype %u, %ux%u, vert %08X", v_type, width>>16, height>>16, (size_t) vert);
	VLL(String);


/*	if(lastSrcStride)
	{
		srcStride = HasPalette(srcFormat)?((lastSrcStride+1)>>1):lastSrcStride;
		pVL_SetSrcStride(cmdbuffer, srcStride);
	}*/
	//VL(tempBuff);
		if(!pVL_Rectangle)
			Error("pVL_Rectangle");
		IndirectSrc(cmdbuffer, true);
	}
#endif

	e = pVL_Rectangle(cmdbuffer, v_type, width, height, vert);

	__asm {
		popad;

		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret 4 * 1;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_Triangle_()
{
	__asm {
		//*******************************
		// Test Code
		//*******************************
		//mov eax, VL_SUCCESS;
		//ret 4;
		//*******************************
		// // End Test Code
		//*******************************
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		pushad;
	}

	//v_u32 EBP;
	__asm {
		/*mov v_type, edx;
		mov v1, ebx;
		mov cmdbuffer, eax;

		mov eax, esp
		mov ebx, [eax + 20];
		mov v3, ebx;*/
		//pop refresh_rate;
		mov cmdbuffer, eax;
		mov v_type, edx;
		mov v1, ebx;
		mov v2, ecx;

		mov eax, esp;
		mov ebx, [eax + 36];
		//mov ebx, [eax + 28];
		//mov ebx, [eax + 20];
		mov v3, ebx;



	}
	//v2 = v1 + (GetVertexSize(v_type)>>2);
	//sprintf_s(tempBuff, 1024, "VL_Triangle_ vt %u, size %u,  v1 %08X, v2 %08X, v3 %08X, %u, %u, %u", v_type, GetVertexSize(v_type),
	//	(size_t)v1, (size_t)v2, (size_t)v3, (size_t)v1, (size_t)v2, (size_t)v3);
	//VL(tempBuff);
#ifdef TEST
	{
		VLL("VL_Triangle_");
		if(!pVL_VertexSize)
		{
			sprintf(String, "VL_Triangle_ vt %u, size (RReady) %u,  v1 %08X, v2 %08X, v3 %08X", v_type, GetVertexSize(v_type),
				(size_t)v1, (size_t)v2, (size_t)v3);
		}
		else
		{
			sprintf(String, "VL_Triangle_ vt %u, size (RReady) %u, Rendition %u, v1 %08X, v2 %08X, v3 %08X", v_type, 
				GetVertexSize(v_type), pVL_VertexSize(v_type),
				(size_t)v1, (size_t)v2, (size_t)v3, pVL_VertexSize);
			IndirectSrc(cmdbuffer, false);
		}
		VLL(String);
		if(!pVL_Triangle)
			Error("pVL_Triangle");
	}
#endif


	{
	/*if(lastSrcStride)
	{
		srcStride = HasPalette(srcFormat)?((lastSrcStride+1)>>1):lastSrcStride;
		pVL_SetSrcStride(cmdbuffer, srcStride);
	}*/

	e = pVL_Triangle(cmdbuffer, v_type, v1, v2, v3);
	
	}
	__asm {

		popad;
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret 4;
		//ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error V_DLLIMPORT VL_Tristrip_()
{
	__asm {
		mov eax, VL_SUCCESS;
		ret;
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/

		pushad;

		mov cmdbuffer, eax;
		mov v_type, edx;
		mov vert_count, ebx;
		mov vert, ecx;
	}
	//sprintf_s(tempBuff, 1024, "VL_Tristrip_ type %u, num %u, verts %08X", v_type, vert_count, (size_t)vert);
#ifdef TEST
	//VL(tempBuff);
	{
	VLL("VL_Tristrip_");
	if(!pVL_Tristrip)
		Error("pVL_Tristrip");
	if(!pVL_VertexSize)
	{
		sprintf(String, "VL_Tristrip_ type %u, sizeA %u, num %u, verts %08X", 
			v_type, GetVertexSize(v_type), vert_count, (size_t)vert);
	}
	else
	{
		sprintf(String,  "VL_Tristrip_ type %u, sizeA %u, sizeB %u num %u, verts %08X", 
			v_type, GetVertexSize(v_type), pVL_VertexSize(v_type), vert_count, (size_t)vert);

	}
	VLL(String);
	IndirectSrc(cmdbuffer, false);

	}
#endif

	/*if(lastSrcStride)
	{
		srcStride = HasPalette(srcFormat)?((lastSrcStride+1)>>1):lastSrcStride;
		pVL_SetSrcStride(cmdbuffer, srcStride);
	}*/

	e = pVL_Tristrip(cmdbuffer, v_type, vert_count, vert);

	__asm {
		popad;

		mov eax, e;
		/*p     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}

__declspec(naked) __declspec(dllexport) vl_error VL_Trifan_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		pushad;


		mov cmdbuffer, eax;
		mov v_type, edx;
		mov vert_count, ebx;
		mov vert, ecx;
	}
	//sprintf_s(tempBuff, 1024, "VL_Trifan_ type %u, num %u, verts %08X", v_type, vert_count, (size_t) vert);
	//VL(tempBuff);
#ifdef TEST
	{
	VLL("VL_Trifan_");
	if(!pVL_Trifan)
		Error("pVL_Trifan");
	if(!pVL_VertexSize)
	{
		sprintf(String, "VL_Trifan_ type %u, sizeA %u, num %u, verts %08X", 
			v_type, GetVertexSize(v_type), vert_count, (size_t)vert);
	}
	else
	{
		sprintf(String,  "VL_Trifan_ type %u, sizeA %u, sizeB %u num %u, verts %08X", 
			v_type, GetVertexSize(v_type), pVL_VertexSize(v_type), vert_count, (size_t)vert);

	}
	VLL(String);
	IndirectSrc(cmdbuffer, false);
	}
#endif

	/*if(lastSrcStride)
	{
		srcStride = HasPalette(srcFormat)?((lastSrcStride+1)>>1):lastSrcStride;
		pVL_SetSrcStride(cmdbuffer, srcStride);
	}*/

	e = pVL_Trifan(cmdbuffer, v_type, vert_count, vert);

	__asm {

		popad;

		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}
}


__declspec(naked) __declspec(dllexport)vl_error VL_FrameMarker_()
{
	__asm {
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
#ifdef PUSHPOP
		pushad;
#endif

		mov cmdbuffer, eax;
		mov v_type, edx;
	}
#ifdef TEST
	//VLLOG("VL_FrameMarker_");
	//ELOG("VL_FrameMarker_");
	{
		VLL("VL_FrameMarker_");
		if(!pVL_FrameMarker)
		{
			VL("Error VL_FrameMarker could not be imported");
		}
	}
#endif

	e = pVL_FrameMarker(cmdbuffer, v_type);

	__asm {
#ifdef PUSHPOP
		popad;
#endif
		mov eax, e;
		/*pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;*/
		ret;
	}

}




/*size_t GetVertexSize(v_u32 v_type)
{
	//unsigned int size{};

	switch (v_type)
	{
	case V_FIFO_XY:
	{
		//LOG("V_FIFO_XY", 6);
		return sizeof(v_xy);// 8;

	}
	case V_FIFO_XYUV:
	{
		//LOG("V_FIFO_XYUV", 6);
		return sizeof(v_xyuv);// 16;
	}
	case V_FIFO_XYUVQ:
	{
		return sizeof(v_xyuvq);// 20;
		break;
	}
	case V_FIFO_IXYUVQ:
	{
		return sizeof(v_ixyuvq);
		break;
	}
	case V_FIFO_FXYUVQ:
	{
		return sizeof(v_fxyuvq); //24;
		break;
	}
	case V_FIFO_RGBFXY:
	{
		return sizeof(v_rgbfxy); //24;
		break;
	}
	case V_FIFO_XYZUVQ:
	{
		return sizeof(v_xyzuvq);
		break;
	}
	case V_FIFO_RGBXYZ:
	{
		//LOG("V_FIFO_XYZUVQ", 6);
		return sizeof(v_rgbxyz);//24;
		break;
	}
	case V_FIFO_IXYZUVQ:
	{
		return sizeof(v_ixyzuvq);;
		break;
	}
	case V_FIFO_IFXYUVQ:
	{
		return sizeof(v_ifxyuvq);// 7 * 4;
		break;
	}
	case V_FIFO_RGBAFXYUVQ:
	{

		return sizeof(v_rgbafxyuvq);
		break;
	}
	case V_FIFO_RGBAXYZUVQ:
	{
		return sizeof(v_rgbaxyzuvq);//; 4 * 10;
		break;
	}
	case V_FIFO_KAFXYUVQ:
	{
		return sizeof(v_kafxyuvq);// 4 * 8;
		break;
	}
	case V_FIFO_KFXY:
	{
		return sizeof(v_kfxy);
		break;
	}
	case V_FIFO_KXYZ:
	{
		return sizeof(v_kxyz);// 4 * 4;
		break;
	}
	case V_FIFO_KFXYZ:
	{
		return sizeof(v_kfxyz);// 4 * 4;
		break;

	}
	case V_FIFO_KXY:
	{

		return sizeof(v_kxy);;// 4 * 3;
		break;
	}
	case V_FIFO_KAFXYZUVQ:
	{
		return sizeof(v_kafxyzuvq);;// 9 * 4;
		break;
	}
	case V_FIFO_AXY:
	{
		return sizeof(v_axy);// 3 * 4;
		break;
	}
	case V_FIFO_KXYUVQ:
	{
		return sizeof(v_kxyuvq);//6 * 4;
		break;
	}
	case V_FIFO_FXYZ:
	{
		return sizeof(v_fxyz);// 4 * 4;
		break;
	}
	case V_FIFO_XYZ:
	{
		return sizeof(v_xyz);// 3 * 4;
		break;
	}
	case V_FIFO_KAXYZUVQ:
	{
		//LOG("V_FIFO_KAXYZUVQ", 6);
		return sizeof(v_kaxyzuvq);;// 32;
		break;
	}
	case V_FIFO_IXYZUV:
	{
		return sizeof(v_ixyzuv);// 4 * 5;
		break;
	}


	case V_FIFO_RGBAFXYZUVQ:
	{
		//LOG("V_FIFO_RGBAFXYZUVQ", 6);
		return sizeof(v_rgbafxyzuvq);// 44;
		break;
	}
	case V_FIFO_KSXYUVQ:
	{
		return sizeof(v_ksxyuvq);// 28;
		break;;
	}
	case V_FIFO_KSXYZUVQ:
	{
		return sizeof(v_ksxyzuvq);// 32;
		break;
	}
	case V_FIFO_KaSFXYZUVQ:
	{
		return sizeof(v_kasfxyzuvq);// 40;
		break;

	}
	default:
	{
		//ELOG(std::format("Unknown vertex size {}", v_type));
		return 0;
	}
	}
	return 0;

}*/

inline size_t GetVertexSize(v_u32 v_type)
{
	//unsigned int size{};

	switch (v_type)
	{
	case V_FIFO_XY:
	{
		//LOG("V_FIFO_XY", 6);
		return sizeof(v_xy);// 8;

	}
	case V_FIFO_XYUV:
	{
		//LOG("V_FIFO_XYUV", 6);
		return sizeof(v_xyuv);// 16;
	}
	case V_FIFO_XYUVQ:
	{
		return sizeof(v_xyuvq);// 20;
		break;
	}
	case V_FIFO_IXYUVQ:
	{
		return sizeof(v_ixyuvq);
		break;
	}
	case V_FIFO_FXYUVQ:
	{
		return sizeof(v_fxyuvq); //24;
		break;
	}
	case V_FIFO_RGBFXY:
	{
		return sizeof(v_rgbfxy); //24;
		break;
	}
	case V_FIFO_XYZUVQ:
	{
		return sizeof(v_xyzuvq);
		break;
	}
	case V_FIFO_RGBXYZ:
	{
		//LOG("V_FIFO_XYZUVQ", 6);
		return sizeof(v_rgbxyz);//24;
		break;
	}
	case V_FIFO_IXYZUVQ:
	{
		return sizeof(v_ixyzuvq);;
		break;
	}
	case V_FIFO_IFXYUVQ:
	{
		return sizeof(v_ifxyuvq);// 7 * 4;
		break;
	}
	case V_FIFO_RGBAFXYUVQ:
	{

		return sizeof(v_rgbafxyuvq);
		break;
	}
	case V_FIFO_RGBAXYZUVQ:
	{
		return sizeof(v_rgbaxyzuvq);//; 4 * 10;
		break;
	}
	case V_FIFO_KAFXYUVQ:
	{
		return sizeof(v_kafxyuvq);// 4 * 8;
		break;
	}
	case V_FIFO_KFXY:
	{
		return sizeof(v_kfxy);
		break;
	}
	case V_FIFO_KXYZ:
	{
		return sizeof(v_kxyz);// 4 * 4;
		break;
	}
	case V_FIFO_KFXYZ:
	{
		return sizeof(v_kfxyz);// 4 * 4;
		break;

	}
	case V_FIFO_KXY:
	{

		return sizeof(v_kxy);;// 4 * 3;
		break;
	}
	case V_FIFO_KAFXYZUVQ:
	{
		return sizeof(v_kafxyzuvq);;// 9 * 4;
		break;
	}
	case V_FIFO_AXY:
	{
		return sizeof(v_axy);// 3 * 4;
		break;
	}
	case V_FIFO_KXYUVQ:
	{
		return sizeof(v_kxyuvq);//6 * 4;
		break;
	}
	case V_FIFO_FXYZ:
	{
		return sizeof(v_fxyz);// 4 * 4;
		break;
	}
	case V_FIFO_XYZ:
	{
		return sizeof(v_xyz);// 3 * 4;
		break;
	}
	case V_FIFO_KAXYZUVQ:
	{
		//LOG("V_FIFO_KAXYZUVQ", 6);
		return sizeof(v_kaxyzuvq);;// 32;
		break;
	}
	case V_FIFO_IXYZUV:
	{
		return sizeof(v_ixyzuv);// 4 * 5;
		break;
	}
	case V_FIFO_IFXYZUVQ:
	{
		return sizeof(v_ifxyzuvq);
		break;
	}

	case V_FIFO_RGBAFXYZUVQ:
	{
		//LOG("V_FIFO_RGBAFXYZUVQ", 6);
		return sizeof(v_rgbafxyzuvq);// 44;
		break;
	}
	case V_FIFO_KSXYUVQ:
	{
		return sizeof(v_ksxyuvq);// 28;
		break;;
	}
	case V_FIFO_KSXYZUVQ:
	{
		return sizeof(v_ksxyzuvq);// 32;
		break;
	}
	case V_FIFO_KaSFXYZUVQ:
	{
		return sizeof(v_kasfxyzuvq);// 40;
		break;

	}
	default:
	{
		//ELOG(std::format("Unknown vertex size {}", v_type));
		return 0;
	}
	}
	return 0;

}


#ifdef INDIRECTSRC
bool IndirectSrc(v_cmdbuffer *cmdbuffer, bool rectangle)
{
	static v_surface *surf=NULL;

	v_u32 width=0, height = 0;

	bool paletted = (PIXELFORMAT == V_PIXFMT_4I_565 ||
			PIXELFORMAT == V_PIXFMT_4I_4444||
			PIXELFORMAT == V_PIXFMT_4I_1555);


	if (rectangle)// && !HasPalette(currentFormat))
	{
		//ELOG(std::format("Rectangle texture masks {}x{}, mults {}x{}",
		//	width, height,
		//	pLib->old.tex.uMultiplier, pLib->old.tex.vMultiplier));

		//if (HasPalette(currentFormat))
		//{
		//	width = (((v_u32)pLib->old.tex.uMultiplier << 1));// >> 1) << 1;
		//	height = (((v_u32)pLib->old.tex.vMultiplier << 1));// >> 1) << 1;
		//}
		//else
		{
			width = UMULT >>16;
			height = VMULT >> 16;
		}
		if (paletted)
		{
		//	base = pLib->old.tex.srcBase;
		//	auto offset = (v_u32)pAlloc->GetBaseAddress();
		//	v_u32 start = (base >= offset) ? (base - offset) : base;
		//	v_u32 end = pLib->maxVRAM - start;

		//	height = ((height * stride + base) >= end) ?
		//		((end - pLib->old.tex.srcBase) / stride):
		//		height;

			//stride = ((stride + 7) >> 3) << 3;
			//width = ((width + 1) >> 1)<<1;
			width = ((width + 3) >> 2) << 2;
			height = ((height + 1))>>1;
			//pLib->old.tex.srcBase = ((pLib->old.tex.srcBase + 1) >> 1) << 1;
			//ELOG(std::format("IndirectSrc dims {}x{}, masks {}x{}, mults {}x{}, paletted {}, format {}, srcMode {}", width, height,
			//	pLib->old.tex.uMask, pLib->old.tex.vMask, pLib->old.tex.uMultiplier, pLib->old.tex.vMultiplier, 
			//	paletted, currentFormat, pLib->old.tex.srcMode));

		}
	}
	else
	{
		width = UMASK+1;
		height = VMASK+1;
	}


	if( surf)
	{
		pVL_DestroySurface(vhandle, surf);
	}
	if(pVL_PointSurface(vhandle, &surf, 0, 1, PIXELFORMAT, width, height, SRCBASE)==VL_SUCCESS && surf)
	{
		return (pVL_InstallTextureMap(cmdbuffer, surf)==VL_SUCCESS);
	}
	return false;
}
#endif
