// Verite.cpp : Defines the entry point for the DLL application.
//

//#include "stdafx.h"
#include "Verite.h"
#include <Redline.h>
#include <verite.h>
#include <redline.h>
#include <vex.h>
#include  <rlfifoex.h>
#include <stdio.h>
//#include <string.h>
#include <stdlib.h>
//#include <map>

//std::map<void *, void *> cmdBufferMap;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


/*// This is an example of an exported variable
VERITE_API int nVerite=0;

// This is an example of an exported function.
VERITE_API int fnVerite(void)
{
	return 42;
}

// This is the constructor of a class that has been exported.
// see Verite.h for the class definition
CVerite::CVerite()
{ 
	return; 
}*/
bool refreshForced=false;
int refreshRate=60;
char String[256];
const size_t bufferMax = 30;
size_t bufferCount=0;
v_cmdbuffer bufferList[bufferMax];

bool libraryLoaded=false;
bool *pNoFlush;

CRITICAL_SECTION oCS;

FILE *log=NULL;

//#define VLS

typedef void (*VLT)(const char*);
VLT pVL=NULL;
//#define RREADY

//#define LOGGING
void LOG(const char *msg)
{
	__asm{
		pushad;
	}

	if(libraryLoaded)
	{
		//EnterCriticalSection(&oCS);

		//SYSTEMTIME st;
		//GetLocalTime(&st);
		EnterCriticalSection(&oCS);

		//fprintf(log, "%02d:%02d:%02d.%03d %s\r\n", st.wHour, st.wMinute, st.wSecond, st.wMilliseconds, msg);

		//fflush(log);

		//fprintf(log, "%s\r\n", msg);
		if(pVL)
			pVL(msg);


		LeaveCriticalSection(&oCS);
	}

	__asm{
		popad;
	};
}

#define DL(a)

#ifndef LOGGING
//#define VLC(a) VLBase(a)
//#define DEBUG
#define VLC(a)
#define VL(a)
#else
#define VL(a) VLBase(a)
#define VLC(a) VLBase(a)
#endif

void VLBase(const char *msg)
{
	__asm{
		pushad;
	}

	if(libraryLoaded)
	{
		EnterCriticalSection(&oCS);

		//fprintf(log, "%02d:%02d:%02d.%03d %s\r\n", st.wHour, st.wMinute, st.wSecond, st.wMilliseconds, msg);

		//fflush(log);

		//fprintf(log, "%s\r\n", msg);

		if(pVL)
			pVL(msg);


		LeaveCriticalSection(&oCS);
	}

	__asm{
		popad;
	};
}


#define PUSHPOP
//#define DIRECTFUNC

	//if(pVL)
	//	pVL(s);
//}

void VLS(const char *s)
{
	//if(pVL)
	//	pVL(s);
	VL(s);
}


void Error(const char *message)
{
	fprintf(log, message);
	fprintf(log, "\n");
	
	//VL(message);
	//MessageBox(NULL, message, "V1000 Formula 1 Wrapper - Verite.DLL", MB_OK);
}

void *nativeCallback=NULL;
typedef v_cmdbuffer (*MassagedCallbackT)(v_handle vhandle, v_cmdbuffer cmdbuffer);

//std::map<v_cmdbuffer, MassagedCallbackT> callbacks;
MassagedCallbackT callbacks[bufferMax];
MassagedCallbackT masterCallback=NULL;
size_t cmdBufferCount = 0;
v_cmdbuffer MassagedCallback(v_handle vhandle, v_cmdbuffer cmdbuffer);

typedef v_u32 (*V_MysteryFuncT)();
typedef v_u32 * (*V_GetMemoryObjectAddressT)(v_memory memory);
typedef v_memory (*V_AllocLockedMemT)(v_handle vhandle, v_u32 size_bytes);
typedef v_error (*V_FreeLockedMemT)(v_handle vhandle, v_memory memory);
typedef v_cmdbuffer (*V_CreateCmdBufferT)(v_handle vhandle, int dmalist_entries, int cmdlist_size);
typedef v_error (*V_IssueCmdBufferT)(v_handle vhandle, v_cmdbuffer cmdbuffer);
typedef v_error (*V_IssueCmdBufferAsyncT)(v_handle vhandle, v_cmdbuffer cmdbuffer);
typedef v_u32 (*V_QueryCmdBufferT)(v_handle vhandle, v_cmdbuffer cmdbuffer);
typedef v_error (*V_DestroyCmdBufferT)(v_cmdbuffer cmdbuffer);
typedef void (*V_SetCmdBufferCallBackT)(v_cmdbuffer cmdbuffer, v_cmdbuffer_callback pfn);
typedef v_u32 * (*V_AddToCmdListT)(v_cmdbuffer *cmdbuffer, v_u32 num_cmd_entries);
typedef v_error (*V_SetDisplayTypeT)(v_handle vhandle, v_u32 app_type);
typedef v_error (*V_SetDisplayModeT)(v_handle vhandle,
				v_u32 width, v_u32 height, v_u32 bpp, 
				v_u32 refresh_rate);
typedef v_error (*V_SetDisplayLinebytesT)(v_handle vhandle, v_u32 linebytes);
typedef void * (*V_LockBufferT)(v_handle vhandle, v_buffer_group buffer_group, v_u32 buffer);
typedef v_error (*V_UnlockBufferT)(v_handle vhandle, v_buffer_group buffer_group, v_u32 buffer);
typedef v_u32 (*V_GetBufferLinebytesT)(v_buffer_group buffer_group, v_u32 buffer);
typedef v_u32 (*V_GetBufferStrideT)(v_buffer_group buffer_group, v_u32 buffer);
typedef v_foreignAddress (*V_GetBufferAddressT)(v_buffer_group buffer_group, v_u32 buffer);
typedef v_error (*V_RegisterSyncCmdT)(v_handle verite, v_u32 sync_cmd);
typedef v_error (*V_CreateVeriteT)(v_u32 board, HWND hwnd, v_handle* pvhandle, char* microcodefile);
typedef v_error (*V_EnumVeriteBoardsT)(HWND hwnd, v_u32 board, v_verite_info* verite_info);
typedef v_error (*V_DestroyVeriteT)(v_handle vhandle);
typedef v_u32 (*V_GetNumBuffersT)(v_buffer_group buffer_group);
typedef v_u32 (*V_GetUseDMAT)(v_handle vhandle);
typedef v_error (*V_CreateBufferGroupT)(v_handle vhandle,
	v_buffer_group* pbuffer_group,
	v_u32* pmemsize,
	v_u32 buffer_mask,
	v_u32 num_buffers,
	v_u32 pixel_fmt,
	v_u32 width,
	v_u32 height);
typedef void (*V_SetUserPrivateT)(v_handle vhandle, v_u32 priv);
typedef v_u32 (*V_GetUserPrivateT)(v_handle vhandle);
typedef v_u32 (*V_LinebytesT)(v_handle vhandle, v_u32 stride);
typedef v_error (*V_BltDisplayBufferT)(v_handle vhandle,
	v_buffer_group dstgroup, v_u32 dstbuffer, v_rect* dstrect,
	v_buffer_group srcgroup, v_u32 srcbuffer, v_rect* srcrect);
typedef v_error (*V_EnumDisplayModesT)
(v_handle verite, v_enumdisplaymodes_callback callback, v_verite_displaymode* filter, void* userdata);

typedef v_error (*V_GetAvailableVidMemT)(v_handle verite, v_u32* total, v_u32* free);

typedef v_error (*V_GetBoardAddressT)(v_handle verite, v_u32* vaddr, v_foreignAddress* board_addr);

typedef HDC (*V_GetBufferDCT)(v_buffer_group buffer_group);
typedef v_error (*V_GetCmdBufferFreeSpaceT)(v_cmdbuffer cmdbuffer, v_u32* pentries, v_u32* pdma_entries);
typedef v_error_handler (*V_GetErrorHandlerT)(void);
typedef v_error (*V_GetErrorTextT)(v_error err, LPSTR s, int nbuff);
typedef v_u32 (*V_StrideT)(v_handle vhandle, v_u32 linebytes);
typedef v_error (*V_UnlockBufferT)(v_handle vhandle, v_buffer_group buffer_group, v_u32 buffer);
typedef v_error (*V_ReleaseBufferDCT)(v_buffer_group buffer_group);
typedef v_error (*V_RegisterErrorHandlerT)(v_error_handler peh);
typedef v_error (*V_ReadBufferT)(v_handle vhandle, v_buffer_group buffer_group,
	v_u32 buffer,
	v_u32 xorg,
	v_u32 yorg,
	v_u32 width,
	v_u32 height,
	v_u32 data_linebytes,
	v_u32* data);
typedef v_error (*V_GetLastErrorT)(v_routine* proutine, v_error* perr, int* pexterr);
typedef v_error (*V_GetLargestBufferT)(v_handle verite, v_buffer_group* pbgroup, v_u32* pmemsize, v_u32 width);
typedef v_error (*V_GetFunctionNameT)(v_routine routine, LPSTR s, int nbuff);


V_EnumDisplayModesT pV_EnumDisplayModes=NULL;
V_BltDisplayBufferT pV_BltDisplayBuffer=NULL;
V_GetAvailableVidMemT pV_GetAvailableVidMem=NULL;
V_GetBoardAddressT pV_GetBoardAddress=NULL;
V_GetBufferDCT pV_GetBufferDC=NULL;
V_GetCmdBufferFreeSpaceT pV_GetCmdBufferFreeSpace=NULL;
V_GetErrorHandlerT pV_GetErrorHandler=NULL;
V_GetErrorTextT pV_GetErrorText=NULL;
V_StrideT pV_Stride=NULL;
V_UnlockBufferT pV_UnlockBufferT=NULL;
V_ReleaseBufferDCT pV_ReleaseBufferDC=NULL;
V_RegisterErrorHandlerT pV_RegisterErrorHandler=NULL;
V_ReadBufferT pV_ReadBuffer=NULL;
V_GetLastErrorT pV_GetLastError=NULL;
V_GetLargestBufferT pV_GetLargestBuffer=NULL;
V_GetFunctionNameT pV_GetFunctionName=NULL;

V_MysteryFuncT V_MysteryFuncImp=NULL;

V_GetMemoryObjectAddressT pV_GetMemoryObjectAddress=NULL;


V_AllocLockedMemT pV_AllocLockedMem=NULL;


V_FreeLockedMemT pV_FreeLockedMem=NULL;


V_CreateCmdBufferT pV_CreateCmdBuffer=NULL;


V_IssueCmdBufferT pV_IssueCmdBuffer=NULL;


V_IssueCmdBufferAsyncT pV_IssueCmdBufferAsync=NULL;


V_QueryCmdBufferT pV_QueryCmdBuffer=NULL;


V_DestroyCmdBufferT pV_DestroyCmdBuffer=NULL;


V_SetCmdBufferCallBackT pV_SetCmdBufferCallBack=NULL;


V_AddToCmdListT pV_AddToCmdList=NULL;


V_SetDisplayTypeT pV_SetDisplayType=NULL;


V_SetDisplayModeT pV_SetDisplayMode=NULL;


V_SetDisplayLinebytesT pV_SetDisplayLinebytes=NULL;


V_LockBufferT pV_LockBuffer=NULL;


V_UnlockBufferT pV_UnlockBuffer=NULL;


V_GetBufferLinebytesT pV_GetBufferLinebytes=NULL;


V_GetBufferStrideT pV_GetBufferStride=NULL;


V_GetBufferAddressT pV_GetBufferAddress=NULL;


V_RegisterSyncCmdT pV_RegisterSyncCmd=NULL;


V_CreateVeriteT pV_CreateVerite=NULL;


V_EnumVeriteBoardsT pV_EnumVeriteBoards=NULL;


V_DestroyVeriteT pV_DestroyVerite=NULL;


V_GetNumBuffersT pV_GetNumBuffers=NULL;


V_GetUseDMAT pV_GetUseDMA=NULL;



V_CreateBufferGroupT pV_CreateBufferGroup=NULL;


V_SetUserPrivateT pV_SetUserPrivate=NULL;



V_GetUserPrivateT pV_GetUserPrivate=NULL;


V_LinebytesT pV_Linebytes=NULL;

typedef v_memory (*V_AllocMemoryObjectT)(v_handle vhandle, v_u32* v_addr, v_u32 size_bytes);
V_AllocMemoryObjectT pV_AllocMemoryObject=NULL;

typedef v_error (*V_SetMemoryObjectT)(v_memory memory, v_u32* v_addr, v_u32 size_bytes);
V_SetMemoryObjectT pV_SetMemoryObject=NULL;

typedef v_u32 (*V_GetMemoryObjectSizeT)(v_memory memory);
V_GetMemoryObjectSizeT pV_GetMemoryObjectSize=NULL;


typedef v_u32 (*V_GetMemoryObjectStatusT)(v_memory memory);
V_GetMemoryObjectStatusT pV_GetMemoryObjectStatus=NULL;

typedef void (*V_FreeMemoryObjectT)(v_handle vhandle, v_memory memory);
V_FreeMemoryObjectT pV_FreeMemoryObject=NULL;

typedef v_error (*V_LockPagesT)(v_handle vhandle, v_memory memory);
V_LockPagesT pV_LockPages=NULL;

typedef v_error (*V_UnlockPagesT)(v_handle vhandle, v_memory memory);
V_UnlockPagesT pV_UnlockPages=NULL;

typedef void (*V_ResetCmdBufferT)(v_cmdbuffer cmdBuffer);
V_ResetCmdBufferT pV_ResetCmdBuffer=NULL;

typedef v_cmdbuffer_callback (*V_GetCmdBufferCallBackT)(v_cmdbuffer cmdbuffer);
V_GetCmdBufferCallBackT pV_GetCmdBufferCallBack=NULL;

typedef v_u32 (*V_GetDMAEntriesT)(v_memory memory, v_u32* v_addr, v_u32 size_words);
V_GetDMAEntriesT pV_GetDMAEntries=NULL;

typedef v_u32* (*V_AddToCmdAndDMAListT)(v_cmdbuffer* cmdBuffer, v_u32 num_cmd_entries,
	v_u32 num_dma_entries);
V_AddToCmdAndDMAListT pV_AddToCmdAndDMAList=NULL;

typedef v_error (*V_AddToDMAListT)(v_cmdbuffer* cmdBuffer, v_u32 fifo_port,
	v_memory memory, v_u32* v_addr, v_u32 size_words);
V_AddToDMAListT pV_AddToDMAList=NULL;

typedef v_handle (*V_GetCmdBufferHandleT)(v_cmdbuffer cmdbuffer);
V_GetCmdBufferHandleT pV_GetCmdBufferHandle=NULL;

typedef v_u32 (*V_GetDisplayTypeT)(v_handle vhandle);
V_GetDisplayTypeT pV_GetDisplayType=NULL;

typedef v_error (*V_SwapBuffersT)(v_buffer_group buffer_group, v_u32 buffer1, v_u32 buffer2);
V_SwapBuffersT pV_SwapBuffers=NULL;

typedef v_u32 (*V_IsBufferLostT)(v_handle vhandle, v_buffer_group buffer_group, v_u32 buffer);
V_IsBufferLostT pV_IsBufferLost=NULL;

typedef v_error (*V_RestoreBufferT)(v_handle vhandle, v_buffer_group buffer_group, v_u32 buffer);
V_RestoreBufferT pV_RestoreBuffer=NULL;

typedef v_error (*V_PointBufferGroupT)(v_handle vhandle, v_buffer_group* pbuffer_group,	v_u32* pmemsize, v_u32 buffer_mask, v_u32 num_buffers, v_u32 pixel_fmt, v_u32 width, v_u32 height,	v_foreignAddress addr);

V_PointBufferGroupT pV_PointBufferGroup=NULL;

typedef v_error (*V_DestroyBufferGroupT)(v_handle vhandle, v_buffer_group buffer_group);
V_DestroyBufferGroupT pV_DestroyBufferGroup=NULL;


typedef v_u32 (*V_GetBufferMaskT)(v_buffer_group buffer_group);
V_GetBufferMaskT pV_GetBufferMask=NULL;

size_t cmdCount = 0;



v_handle vhandle;
v_u32 width, height, bpp;
v_u32 refresh_rate;
v_error e;
v_u32 app_type;
v_u32 linebytes;
v_cmdbuffer *pCmdBuffer;
v_cmdbuffer cmdbufferA, cmdbufferB, cmdbufferC, cmdbufferD, cmdbufferE, cmdbufferF;
v_u32 numCmds;
v_u32 dmas;
//v_cmdbuffer cmdbuffer;
v_cmdbuffer_callback pfn;
v_buffer_group buffer_group;
v_u32 buffer;
v_u32 queryCmdBuffer;
v_u32 size_bytes;
v_u32* v_u32Ptr;
v_memory memory;
//size_t i=0;
void* voidPtr;
size_t lastQueryBuffer={0xFFFFFFFF};
size_t queryCount=0;

char tempBuff[1024];



void LoadLibrary()
{
	InitializeCriticalSection(&oCS);

	log = fopen("V2k.RReady.Verite.txt", "w+");

	if(!log)
	{
		MessageBox(NULL, "Could not open log file", "V2k.RReady", MB_OK);
		exit(1);
	}

	{
		SYSTEMTIME st;
		GetLocalTime(&st);
		EnterCriticalSection(&oCS);

		fprintf(log, "%04d/%02d/%02d %02d:%02d:%02d.%03d Started logging\r\n", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
	}

	{
		FILE *g = fopen("Refresh.txt", "rt");
		if(!g)
		{
			refreshForced = false;
			fprintf(log, "Refresh rate not forced\n");
		}
		else
		{
			refreshForced = true;
			fscanf(g, "%d", &refreshRate);
			sprintf(String, "Forced refresh rate is %d\n", refreshRate);
			fprintf(log, String);
			

		}
	}



	char buff[MAX_PATH];
	GetSystemDirectory(buff, MAX_PATH);
	int len = strlen(buff);
	if(buff[len-1] != '\\')
		strcat(buff, "\\");
#ifdef RREADY
	strcat(buff, "Verite2.dll");
#else
	strcat(buff, "Verite.dll");
#endif
	HMODULE hLib = LoadLibrary(buff);
	if( hLib)
	{
		pV_GetMemoryObjectAddress = (V_GetMemoryObjectAddressT)GetProcAddress(hLib, "V_GetMemoryObjectAddress");

		pV_AllocLockedMem = (V_AllocLockedMemT)GetProcAddress(hLib, "V_AllocLockedMem");

		pV_FreeLockedMem = (V_FreeLockedMemT)GetProcAddress(hLib, "V_FreeLockedMem");

		pV_CreateCmdBuffer = (V_CreateCmdBufferT)GetProcAddress(hLib, "V_CreateCmdBuffer");

		pV_IssueCmdBuffer= (V_IssueCmdBufferT) GetProcAddress(hLib, "V_IssueCmdBuffer");

		pV_IssueCmdBufferAsync = (V_IssueCmdBufferAsyncT) GetProcAddress(hLib, "V_IssueCmdBufferAsync");

		pV_QueryCmdBuffer= (V_QueryCmdBufferT) GetProcAddress(hLib, "V_QueryCmdBuffer");

		pV_DestroyCmdBuffer = (V_DestroyCmdBufferT) GetProcAddress(hLib, "V_DestroyCmdBuffer");

		pV_SetCmdBufferCallBack = (V_SetCmdBufferCallBackT) GetProcAddress(hLib, "V_SetCmdBufferCallBack");

		pV_AddToCmdList = (V_AddToCmdListT) GetProcAddress(hLib, "V_AddToCmdList");

		pV_SetDisplayType = (V_SetDisplayTypeT) GetProcAddress(hLib, "V_SetDisplayType");

		pV_SetDisplayMode= (V_SetDisplayModeT) GetProcAddress(hLib, "V_SetDisplayMode");

		pV_SetDisplayLinebytes = (V_SetDisplayLinebytesT)GetProcAddress(hLib, "V_SetDisplayLinebytes");

		pV_LockBuffer = (V_LockBufferT)GetProcAddress(hLib, "V_LockBuffer");

		pV_UnlockBuffer = (V_UnlockBufferT)GetProcAddress(hLib, "V_UnlockBuffer");

		pV_GetBufferLinebytes = (V_GetBufferLinebytesT)GetProcAddress(hLib, "V_GetBufferLinebytes");

		pV_GetBufferStride = (V_GetBufferStrideT)GetProcAddress(hLib, "V_GetBufferStride");

		pV_GetBufferAddress = (V_GetBufferAddressT)GetProcAddress(hLib, "V_GetBufferAddress");

		pV_RegisterSyncCmd = (V_RegisterSyncCmdT)GetProcAddress(hLib, "V_RegisterSyncCmd");

		pV_CreateVerite = (V_CreateVeriteT)GetProcAddress(hLib, "V_CreateVerite");

		pV_EnumVeriteBoards = (V_EnumVeriteBoardsT)GetProcAddress(hLib, "V_EnumVeriteBoards");

		pV_DestroyVerite = (V_DestroyVeriteT)GetProcAddress(hLib, "V_DestroyVerite");
		
		pV_GetNumBuffers = (V_GetNumBuffersT)GetProcAddress(hLib, "V_GetNumBuffers");

		pV_GetUseDMA = (V_GetUseDMAT)GetProcAddress(hLib, "V_GetUseDMA");

		pV_CreateBufferGroup = (V_CreateBufferGroupT)GetProcAddress(hLib, "V_CreateBufferGroup");
		
		pV_SetUserPrivate = (V_SetUserPrivateT)GetProcAddress(hLib, "V_SetUserPrivate");

		pV_GetUserPrivate = (V_GetUserPrivateT)GetProcAddress(hLib, "V_GetUserPrivate");

		pV_Linebytes = (V_LinebytesT)GetProcAddress(hLib, "V_Linebytes");
		
		pV_AllocMemoryObject = (V_AllocMemoryObjectT)GetProcAddress(hLib, "V_AllocMemoryObject");
		
		pV_SetMemoryObject = (V_SetMemoryObjectT)GetProcAddress(hLib, "V_SetMemoryObject");

		pV_GetMemoryObjectSize = (V_GetMemoryObjectSizeT)GetProcAddress(hLib, "V_GetMemoryObjectSize");

		pV_GetMemoryObjectStatus = (V_GetMemoryObjectStatusT)GetProcAddress(hLib, "V_GetMemoryObjectStatus");

		pV_FreeMemoryObject = (V_FreeMemoryObjectT)GetProcAddress(hLib, "V_FreeMemoryObject");

		pV_LockPages = (V_LockPagesT)GetProcAddress(hLib, "V_LockPages");
		
		pV_UnlockPages = (V_UnlockPagesT)GetProcAddress(hLib, "V_UnlockPages");

		pV_ResetCmdBuffer = (V_ResetCmdBufferT)GetProcAddress(hLib, "V_ResetCmdBuffer");

		pV_GetCmdBufferCallBack = (V_GetCmdBufferCallBackT)GetProcAddress(hLib, "V_GetCmdBufferCallBack");
		
		pV_GetDMAEntries= (V_GetDMAEntriesT)GetProcAddress(hLib, "V_GetDMAEntries");

		pV_AddToCmdAndDMAList = (V_AddToCmdAndDMAListT)GetProcAddress(hLib, "V_AddToCmdAndDMAList");
		
		pV_AddToDMAList = (V_AddToDMAListT)GetProcAddress(hLib, "V_AddToDMAList");		
		
		pV_GetCmdBufferHandle = (V_GetCmdBufferHandleT)GetProcAddress(hLib, "V_GetCmdBufferHandle");

		pV_GetDisplayType = (V_GetDisplayTypeT)GetProcAddress(hLib, "V_GetDisplayType");
		
		pV_SwapBuffers = (V_SwapBuffersT)GetProcAddress(hLib, "V_SwapBuffers");

		pV_IsBufferLost = (V_IsBufferLostT)GetProcAddress(hLib, "V_IsBufferLost");
		
		pV_RestoreBuffer = (V_RestoreBufferT)GetProcAddress(hLib, "V_RestoreBuffer");

		pV_PointBufferGroup = (V_PointBufferGroupT)GetProcAddress(hLib, "V_PointBufferGroup");
		
		pV_DestroyBufferGroup = (V_DestroyBufferGroupT)GetProcAddress(hLib, "V_DestroyBufferGroup");

		pV_GetBufferMask = (V_GetBufferMaskT)GetProcAddress(hLib, "V_GetBufferMask");

		pV_BltDisplayBuffer = (V_BltDisplayBufferT)GetProcAddress(hLib, "V_BltDisplayBuffer");

		pV_EnumDisplayModes = (V_EnumDisplayModesT)GetProcAddress(hLib, "V_EnumDisplayModes");

		pV_GetAvailableVidMem = (V_GetAvailableVidMemT) GetProcAddress(hLib, "V_GetAvailableVidMem");

		pV_GetBoardAddress = (V_GetBoardAddressT)GetProcAddress(hLib, "V_GetBoardAddress");

		pV_GetBufferDC = (V_GetBufferDCT)GetProcAddress(hLib, "V_GetBufferDC");

		pV_GetCmdBufferFreeSpace = (V_GetCmdBufferFreeSpaceT)GetProcAddress(hLib, "V_GetCmdBufferFreeSpace");

		pV_GetErrorHandler = (V_GetErrorHandlerT)GetProcAddress(hLib, "V_GetErrorHandler");

		pV_GetErrorText = (V_GetErrorTextT)GetProcAddress(hLib, "V_GetErrorText");

		pV_Stride = (V_StrideT)GetProcAddress(hLib, "V_Stride");

		pV_UnlockBuffer = (V_UnlockBufferT)GetProcAddress(hLib, "V_UnlockBuffer");

		pV_ReleaseBufferDC = (V_ReleaseBufferDCT)GetProcAddress(hLib, "V_ReleaseBufferDC");

		pV_RegisterErrorHandler = (V_RegisterErrorHandlerT)GetProcAddress(hLib, "V_RegisterErrorHandler");

		pV_ReadBuffer = (V_ReadBufferT)GetProcAddress(hLib, "V_ReadBuffer");

		pV_GetLastError = (V_GetLastErrorT)GetProcAddress(hLib, "V_GetLastError");


		pV_GetLargestBuffer =(V_GetLargestBufferT)GetProcAddress(hLib, "V_GetLargestBuffer");

		pV_GetFunctionName = (V_GetFunctionNameT)GetProcAddress(hLib, "V_GetFunctionName");


		V_MysteryFuncImp = (V_MysteryFuncT)GetProcAddress(hLib, (PCSTR)138);


		{
			GetModuleFileName(NULL, buff, MAX_PATH);

			char *ptr = strrchr(buff, '\\');
			*(ptr+1) = 0;
			strcat(buff, "redline.dll");

			fprintf(log, "(local) Redline.DLL %s\n", buff);

			HMODULE hV2kR = LoadLibrary(buff);

			if(hV2kR)
			{
				pNoFlush = (bool *)GetProcAddress(hV2kR, "noFlush");
				if(pNoFlush)
				{
					fprintf(log, "Successfully loaded library (local) Redline.DLL\n");
				}
			}
			else
			{
				fprintf(log, "Failed to load library (local) Redline.DLL\n");
				MessageBoxA(NULL, "LoadLibrary (local) failed Redline.DLL", buff, MB_OK);				
			}


		}

		libraryLoaded= (pNoFlush && pV_GetMemoryObjectAddress&&
pV_AllocLockedMem&&
pV_FreeLockedMem&&
pV_CreateCmdBuffer&&
pV_IssueCmdBuffer&&
pV_IssueCmdBufferAsync&&
pV_QueryCmdBuffer&&
pV_DestroyCmdBuffer&&
pV_SetCmdBufferCallBack&&
pV_AddToCmdList&&
pV_SetDisplayType&&
pV_SetDisplayMode&&
pV_SetDisplayLinebytes&&
pV_LockBuffer&&
pV_UnlockBuffer&&
pV_GetBufferLinebytes&&
pV_GetBufferStride&&
pV_GetBufferAddress&&
pV_RegisterSyncCmd&&
pV_CreateVerite&&
pV_EnumVeriteBoards&&
pV_DestroyVerite&&
pV_GetNumBuffers&&
pV_GetUseDMA&&
pV_CreateBufferGroup&&
pV_SetUserPrivate&&
pV_GetUserPrivate&&
pV_Linebytes&&
pV_AllocMemoryObject&&
pV_SetMemoryObject&&
pV_GetMemoryObjectSize&&
pV_GetMemoryObjectStatus&&
pV_FreeMemoryObject&&
pV_LockPages&&
pV_UnlockPages&&
pV_ResetCmdBuffer&&
pV_GetCmdBufferCallBack&&
pV_GetDMAEntries&&
pV_AddToCmdAndDMAList&&
pV_AddToDMAList&&
pV_GetCmdBufferHandle&&
pV_GetDisplayType&&
pV_SwapBuffers&&
pV_IsBufferLost&&
pV_RestoreBuffer&&
pV_PointBufferGroup&&
pV_DestroyBufferGroup&&
pV_GetBufferMask&&
pV_BltDisplayBuffer&&
pV_EnumDisplayModes&&
pV_GetAvailableVidMem&&
pV_GetBoardAddress&&
pV_GetBufferDC&&
pV_GetCmdBufferFreeSpace&&
pV_GetErrorHandler&&
pV_GetErrorText&&
pV_Stride&&
pV_UnlockBuffer&&
pV_ReleaseBufferDC&&
pV_RegisterErrorHandler&&
pV_ReadBuffer&&
pV_GetLastError&&
pV_GetLargestBuffer&&
pV_GetFunctionName );
	
		if(!libraryLoaded)
		{
			fprintf(log, "Failed to load all library functions (Verite.DLL)");
			MessageBoxA(NULL, "Failed to load all library functions", "Verite.DLL", MB_OK);
		}
		else
		{
			fprintf(log, "Successfully loaded all library functions (Verite.DLL)");
		}

		HINSTANCE hInst=GetModuleHandle(0); 

		const int length = 1024;
		char path[length];

		GetModuleFileNameA(hInst, path, length);

		char *last = strrchr(path, '\\');
		if(last)
		{
			*(last)=0;
			strcat(last, "\\redline.dll");

			

			HMODULE localLib = LoadLibrary(path);
			if(localLib)
			{
				pVL = (VLT)GetProcAddress(localLib, "VL");
				if(!pVL)
				{
					MessageBoxA(NULL, "Logging function missing in V2k.RReady's Redline.DLL", buff, MB_OK);

					

				}
			}
			else
			{
				MessageBoxA(NULL, "LoadLibrary (forumula 1 folder) failed Redline.DLL", buff, MB_OK);


			}
		}

		fprintf(log, "Loaded system\\Verite.dll library");
		
	}
	else
	{
		fprintf(log, "Failed to load library");
		MessageBoxA(NULL, "LoadLibrary (system) failed Verite.DLL", buff, MB_OK);
		exit(1);
	}

}




__declspec(naked) v_u32* V_GetMemoryObjectAddress_()
{
	__asm{
		mov memory, eax;

		pushad;

	}
#ifdef DEBUG
	{
		sprintf(String, "V_GetMemoryObjectAddress_ %08X", (size_t)memory);
		DL(String);
	}

	VL("V_GetMemoryObjectAddress__");
	if(!pV_GetMemoryObjectAddress)
	{
		Error("pV_GetMemoryObjectAddress");
	}
#endif
	v_u32Ptr =  pV_GetMemoryObjectAddress(memory);
	__asm {
		popad;
		mov eax, v_u32Ptr;

		ret;
	}
}


__declspec(naked) v_memory V_AllocLockedMem_()
{

	__asm {
		mov size_bytes, edx;
		mov vhandle, eax;
		pushad;
	}



#ifdef DEBUG
	{
		sprintf(String, "V_AllocLockedMem_  vhandle %08X, bytes %u", (size_t)memory, size_bytes);
		DL(String);
	}


	VL("V_AllocLockedMem");
	if(!pV_AllocLockedMem)
	{
		Error("pV_AllocLockedMem");
	}

#endif

	memory =   pV_AllocLockedMem(vhandle, size_bytes);
	__asm {
		popad;
		mov eax, memory;
		ret;
	}

}


__declspec(naked) v_error V_FreeLockedMem_()
{
	__asm {
		pushad;
	}


	__asm {
		mov vhandle, eax;
		mov memory, edx;
	}
#ifdef DEBUG
	{
		sprintf(String, "V_FreeLockedMem_ %08X", (size_t)memory);
		DL(String);
	}


	VL("V_FreeLockedMem_");
	if(!pV_FreeLockedMem)
		Error("pV_FreeLockedMem");
#endif

	e = pV_FreeLockedMem(vhandle, memory);

	__asm {
		popad;
		mov eax, e;
		ret;
	}

}

__declspec(naked) v_cmdbuffer V_CreateCmdBuffer_()
{


	__asm{
		pushad;
		//shl ebx, 2
		mov numCmds, ebx;
		//shl edx, 2
		mov dmas, edx;

		mov vhandle, eax;
	}



#ifdef DEBUG
	{
		sprintf(String, "V_GetMemoryObjectAddress_ %08X", (size_t)memory);
		DL(String);
	}


	if(!libraryLoaded)
		LoadLibrary();
	VL("V_CreateCmdBuffer entry");


	if(!pV_CreateCmdBuffer)
		Error("pV_CreateCmdBuffer");
#endif

	cmdbufferF = pV_CreateCmdBuffer(vhandle, dmas, numCmds); ;// *cmdBufferPtr;
#ifdef PUSHPOP
	if(bufferCount < bufferMax)
	{
		bufferList[bufferCount] = cmdbufferF;
		bufferCount++;
	}
#endif


	__asm {

		popad;
		mov eax, cmdbufferF;



		ret;
	}


}



__declspec(naked) v_error V_IssueCmdBuffer_()
{
	__asm {
		mov vhandle, eax;
		mov cmdbufferA, edx;
		//push    ebx;
		//push    ecx;
		//push    esi;
		//push    edi;
		pushad;
		//push ebp;
		//mov ebp, esp;

	}

#ifdef DEBUG
	{
		sprintf(String, "V_IssueCmdBuffer_ vhandle %08X, cmdbuffer %08X", (size_t)vhandle, (size_t) cmdbufferA);
		DL(String);
	}


	{
		VLC("V_IssueCmdBuffer_");
		if(!pV_IssueCmdBuffer)
			Error("pV_IssueCmdBuffer");

	}
#endif

	//VLLOG("V_IssueCmdBuffer_");
#ifdef DUMP
	{
		for(size_t i = 0; i < bufferCount; i++)
		{
			if(bufferList[i] == cmdbufferA)
				break;
		}
		sprintf(String, "L_IssueCmdBuffer_ buffer id %u", i);
		VLC(String);
	}
#endif
	e =  pV_IssueCmdBuffer(vhandle, cmdbufferA);

	//{
		V_ResetCmdBuffer(cmdbufferA);
	//}

	__asm {
		//pop ebp;
		popad;
		mov eax, e;
		ret;
	}

}


__declspec(naked) v_error V_IssueCmdBufferAsync_()
{

	__asm {
		mov vhandle, eax;
		mov cmdbufferB, edx;
		pushad;
		//push ebp;
		//mov ebp, esp;
	}
#ifdef DUMP
	{
		VL("V_IssueCmdBufferAsync_");
		if(!pV_IssueCmdBufferAsync)
		Error("pV_IssueCmdBufferAsync");

		for(size_t i = 0; i < bufferCount; i++)
		{
			if(bufferList[i] == cmdbufferB)
				break;
		}
		sprintf(String, "VL_IssueCmdBufferAync_ buffer id %u", i);
		VLC(String);
	}
#endif

	e = pV_IssueCmdBufferAsync(vhandle, cmdbufferB);

	__asm {
		popad;
		mov eax, e;
		//pop ebp;
		//pop     edi;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
		ret;
	}


}


__declspec(naked) v_u32 V_QueryCmdBuffer_()
{

	__asm {
		mov vhandle, eax;
		mov cmdbufferC, edx;

		pushad;

		//push ebp;
		//mov ebp, esp;
	}
	//sprintf_s(tempBuff, 1024, "V_QueryCmdBuffer_ vhandle %08X, cmdbuffer %08X", (size_t)vhandle, (size_t)cmdbuffer);
	//VL(tempBuff);
	//VL("V_QueryCmdBuffer_");
#ifdef DUMP
	{
		if(!pV_QueryCmdBuffer)
			Error("pV_QueryCmdBuffer");
	}
#endif

	queryCmdBuffer = pV_QueryCmdBuffer(vhandle, cmdbufferC);

#ifdef DUMP
	{
		for(size_t i = 0; i < bufferCount; i++)
		{
			if(bufferList[i] == cmdbufferC)
				break;
		}
		sprintf(String, "V_QueryCmdBuffer_ id %u returned %u", i, queryCmdBuffer);
		VLC(String);
		/*if( queryCmdBuffer == V_CMDBUFFER_INUSE)
		{
			if( i == lastQueryBuffer && queryCount > 
			queryCount++;
			if(queryCount > 100)
			{
				
			}
			//lastQueryBuffer = i;
			//Sleep(10);
		}
		else
		{
			queryCount = 0;
			lastQueryBuffer = 0xFFFFFFFF;
		}*/
	
	}
#endif
	//sprintf_s(tempBuff, 1024, "Returning %d", e);
	//VL(tempBuff);
	__asm {

		popad;
		//pop ebp;
		mov eax, queryCmdBuffer;
		//pop     edi;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
		ret;
	}

}


__declspec(naked) v_error V_DLLIMPORT V_DestroyCmdBuffer_()
{
	__asm {
		mov cmdbufferD, eax;
		pushad;
	}

	//sprintf_s(tempBuff, 1024, "V_DestroyCmdBuffer_ %08X", (size_t)cmdbuffer);
#ifdef DUMP
	VL("V_DestroyCmdBuffer_");
	//VL(tempBuff);
	if(!pV_DestroyCmdBuffer)
		Error("pV_DestroyCmdBuffer");
#endif

	e =  pV_DestroyCmdBuffer(cmdbufferD);
	__asm {
		popad;
		mov eax, e;
		//pop     edi;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
		ret;
	}
	//VLLOG("V_DestroyCmdBuffer_");

}

/*void AddFunction(v_cmdbuffer buffer, v_cmdbuffer_callback func)
{
	cmdBufferMap[buffer] = func;
}*/

__declspec(naked) void V_MysteryFunc_()
{
	__asm{
		pushad;
	}
#ifdef DUMP
	{
	VL("MysteryFunc");
	LOG("MysteryFunc");
	}
#endif

	e = V_MysteryFuncImp();
	
	__asm{
		popad;
		mov eax, e;
		ret;
	}
}


__declspec(naked) void V_SetCmdBufferCallBack_()
{
	//VLLOG("V_SetCmdBufferCallBack_");

	__asm{
		/*push    ebx;
		push    ecx;
		push    esi;
		push    edi;*/
		pushad;
		mov cmdbufferE, eax;
		mov pfn, edx;
		//mov nativeCallback, edx;
	}
#ifdef DUMP
	VL("V_SetCmdBufferCallback_");
	if(!pV_SetCmdBufferCallBack)
		Error("pV_SetCmdBufferCallBack");
#endif

#ifdef DIRECTFUNC
	pV_SetCmdBufferCallBack(cmdbufferE, pfn);
#else
#ifdef DUMP
	{
		//callbacks[cmdbufferE] = pfn;
		for (size_t i = 0; i < bufferMax; i++)
		{
			if (cmdbufferE == bufferList[i])
				break;
		}
		callbacks[i] = pfn;
	}
#else
	masterCallback = pfn;
#endif

	//AddFunction(cmdbuffer, pfn);
	pV_SetCmdBufferCallBack(cmdbufferE, MassagedCallback);
#endif
	__asm{
		popad;
		ret;
	}
}


__declspec(naked) v_u32* V_AddToCmdList_()
{
	__asm {
		pushad;
		//push    ebx;
		//push    ecx;
		//push    esi;
		//push    edi;
		mov pCmdBuffer, eax;
		//mov v13, esp;
		mov numCmds, edx;
	}
	//sprintf_s(tempBuff, "V_AddToCmdList_ cmdbuffer %08X, num %u", (size_t)cmdbuffer, numCmds);
	//VL(tempBuff);
#ifdef DUMP
	{
#ifdef LOGGING
		sprintf(String, "V_AddToCmdList %u", numCmds);
	//VL("V_AddToCmdList_");
#endif
	if(!pV_AddToCmdList)
		Error("pV_AddToCmdList");
			if(numCmds==9)
			{
	
		for(size_t i = 0; i < bufferCount; i++)
		{
			if(bufferList[i] == *pCmdBuffer)
				break;
		}
		sprintf(String, "V_AddToCmdList_ id %u, %s numCmds %u", i, (numCmds==9?"(possible V_FIFO_TEXT4PAL)":""), numCmds);
		VL(String);
		}
	}
#endif	

	//v_handle vhandle = (*cmdBuffer)->vhandle;
	//v_cmdbuffer_callback callback = (*cmdBuffer)->callback;
	//if (!vhandle->IsValid())
	//	ELOG(std::format("CommmanddListAppend buffer id {}, vhandle is invalid {:08X}", 
	//		(size_t)buff->id, (size_t)vhandle->magic));

	//*pCmdBuffer = MassagedCallback(vhandle, *pCmdBuffer);
			


	v_u32Ptr = pV_AddToCmdList(pCmdBuffer, numCmds);
	__asm {
		popad;
		mov eax, v_u32Ptr;
		//pop     edi;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
		ret;
		//add esp, 0Ch;
	}

}


__declspec(naked) v_error V_SetDisplayType_()
{
	//v_handle vhandle;
	//v_u32 app_type;
	__asm {
		pushad;

		mov vhandle, eax;
		mov app_type, edx;
	}
	//sprintf_s(tempBuff, 1024, "V_SetDisplayType_ %08X", app_type);
	//VL(tempBuff);
	//v_error e;
#ifdef DUMP
	VL("V_SetDisplayType_");
	if(!pV_SetDisplayType)
		Error("pV_SetDisplayType");
#endif

	e = pV_SetDisplayType(vhandle, app_type);
	__asm {
		popad;
		mov eax, e;
		//pop     edi;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
		ret;
	}
}


__declspec(naked) v_error V_SetDisplayMode_()
{
#ifdef PUSHPOP
	__asm {

		push ecx;
		push edx;
		push ebx;

		push ebp;
		push esi;
		push edi;
		//push    ebx;
		//push    ecx;
		//push    esi;
		//push    edi;
	}

	//v_u32 EBP;
	__asm {
		mov width, edx;
		mov height, ebx;
		mov bpp, ecx;
		mov vhandle, eax;
		mov eax, esp
		mov ebx, [eax + 28];
		mov refresh_rate, ebx;
		//pop refresh_rate;


	}
#else

	//v_u32 EBP;
	__asm {
		mov width, edx;
		mov height, ebx;
		mov bpp, ecx;
		mov vhandle, eax;
		mov eax, esp
		mov ebx, [eax + 4];
		mov refresh_rate, ebx;
		//pop refresh_rate;


	}

#endif
	//sprintf_s(tempBuff, 1024, "V_SetDisplayMode_ vhandle %08X, %dx%d @%d", (size_t)vhandle, width, height, refresh_rate);
	//VL(tempBuff);
#ifdef DUMP
	VL("V_SetDisplayMode_");
	if(!pV_SetDisplayMode)
		Error("pV_SetDisplayMode");
#endif

	e = pV_SetDisplayMode(vhandle,
		width, height, bpp,
		refreshForced?refreshRate:refresh_rate);
	__asm {
		mov eax, e;
		//pop     edi;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
#ifdef PUSHPOP
		pop edi;
		pop esi;
		pop ebp;
		pop ebx;
		pop edx;
		pop ecx;
#endif

		ret 4;
		//ret;
	}
}


__declspec(naked) v_error V_SetDisplayLinebytes_()
{
	//v_handle vhandle;
	
	__asm {
		mov vhandle, eax;
		mov linebytes, edx;
		pushad;
		//push    ebx;
		//push    ecx;
		//push    esi;
		//push    edi;
	}
	//sprintf_s(tempBuff, 1024, "V_SetDisplayLinebytes_ vhandle %08d, linebytes %08d", (size_t)vhandle, linebytes);
	//VL(tempBuff);
#ifdef DUMP
	VL("V_SetDisplayLinebytes_");
	//v_error e;
	if(!pV_SetDisplayLinebytes)
		Error("pV_SetDisplayLinebytes");
#endif

	e =  pV_SetDisplayLinebytes(vhandle, linebytes);
	__asm {
		popad;
		mov eax, e;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
		ret;
	}
}


__declspec(naked) void* V_LockBuffer_()
{
	__asm {
		pushad;
		//push    ebx;
		//push    ecx;
		//push    esi;
		//push    edi;

		mov vhandle, eax;
		mov buffer_group, edx;
		mov buffer, ebx;
	}
	//v_handle vhandle, v_buffer_group buffer_group, v_u32 buffer
	//sprintf_s(tempBuff, 1024, "V_LockBuffer_ vhandle %08X, buffer_group %08X, buffer %u", (size_t)vhandle, (size_t)buffer_group, buffer);
	//;VL(tempBuff);
#ifdef DUMP
	VL("V_LockBuffer_");
	if(!pV_LockBuffer)
		Error("pV_LockBuffer");
#endif

	voidPtr = pV_LockBuffer(vhandle, buffer_group, buffer);

	__asm {
		popad;
		mov eax, voidPtr;
		//pop     edi;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
		ret;
	}


}


__declspec(naked) v_error V_DLLIMPORT V_UnlockBuffer_()
{
	
//	return V_UnlockBuffer(vhandle, buffer_group, buffer);

	__asm {
		pushad;
		//push    ebx;
		//push    ecx;
		//push    esi;
		//push    edi;

		mov vhandle, eax;
		mov buffer_group, edx;
		mov buffer, ebx;
	}
	//VL("V_UnlockBuffer_");
	//v_handle vhandle, v_buffer_group buffer_group, v_u32 buffer
	//sprintf_s(tempBuff, 1024, "V_UnlockBuffer_ vhandle %08X, buffer_group %08X, buffer %u", (size_t)vhandle, (size_t)buffer_group, buffer);
	//VL(tempBuff);
#ifdef DUMP
	VL("V_UnlockBuffer_");
	if(!pV_UnlockBuffer)
		Error("pV_UnlockBuffer");
#endif

	e = pV_UnlockBuffer(vhandle, buffer_group, buffer);

	__asm {
		popad;
		mov eax, e;
		ret;
	}
}


__declspec(naked) v_u32 V_GetBufferLinebytes_()
{

	__asm {
		mov buffer_group, eax;
		mov buffer, edx;
		pushad;
		//push    ebx;
		//push    ecx;
		//push    esi;
		//push    edi;
	}
	//sprintf_s(tempBuff, 1024, "V_GetBufferLinebytes_ buffer_group %08d, buffer num %d", (size_t)buffer_group, buffer);
	//VL(tempBuff);
	//v_u32 e;
#ifdef DUMP
	VL("V_GetBufferLinebytes_");
	if(!pV_GetBufferLinebytes)
		Error("pV_GetBufferLinebytes");
#endif

	e = pV_GetBufferLinebytes(buffer_group, buffer);
	__asm{
		popad;
		mov eax, e;
		//pop     edi;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
		ret;
	}
}


__declspec(naked) v_u32 V_GetBufferStride_()
{
	__asm {
		pushad;
		//push    ebx;
		//push    ecx;
		//push    esi;
		//push    edi;

		mov buffer_group, eax;
		mov buffer, edx;
	}
	//sprintf_s(tempBuff, 1024, "V_GetBufferStride_ buffer group %08X, buffer %u", (size_t)buffer_group, buffer);
	//VL(tempBuff);
#ifdef DUMP
	VL("V_GetBufferStride_");

	if(!pV_GetBufferStride)
		Error("pV_GetBufferStride");
#endif

	e = (v_error)pV_GetBufferStride(buffer_group, buffer);

	__asm {
		popad;
		mov eax, e;
		//pop     edi;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
		ret;
	}

	//VLLOG("V_GetBufferStride_");
	//return V_GetBufferStride(buffer_group, buffer);
}


__declspec(naked) v_foreignAddress V_GetBufferAddress_()
{
	//VLLOG("V_GetBufferAddress_");
	//return V_GetBufferAddress(buffer_group, buffer);

	__asm {
		pushad;
		//push    ebx;
		//push    ecx;
		//push    esi;
		//push    edi;

		mov buffer_group, eax;
		mov buffer, edx;
	}
	//sprintf_s(tempBuff, 1024, "V_GetBufferAddress_ buffer group %08X, buffer %u", (size_t)buffer_group, buffer);
	//VL(tempBuff);
#ifdef DUMP
	VL("V_GetBufferAddress_");

	if(!pV_GetBufferAddress)
		Error("pV_GetBufferAddress");
#endif

	e = (v_error) pV_GetBufferAddress(buffer_group, buffer);

	__asm {
		popad;
		mov eax, e;
		
		//pop     edi;
		//pop     esi;
		//pop     ecx;
		//pop     ebx;
		ret;
	}

}


v_error V_RegisterSyncCmd(v_handle verite, v_u32 sync_cmd)
{
	//VLLOG("V_RegisterSyncCmd");
	//LOG("V_RegisterSyncCmd", 1);
	//ELOG("V_RegisterSyncCmd");
	//'return AddVError(9, "V_RegisterSyncCmd not implemented");
#ifdef DUMP
	VLS("V_RegisterSyncCmd");
	if(!pV_RegisterSyncCmd)
		Error("pV_RegisterSyncCmd");
#endif

	pV_RegisterSyncCmd(verite, sync_cmd); 
	return V_SUCCESS;
	//return VERROR_GEN(9, 1);
}


v_error V_DLLIMPORT V_CreateVerite(v_u32 board, HWND hwnd, v_handle* pvhandle, char* microcodefile)
{
#ifdef DUMP
	VLS("V_CreateVerite");
	if(!pV_CreateVerite)
		Error("pV_CreateVerite");
#endif

	//char path[512]={"WINSPD3D.UC"};
	char path[512]={"V10003D.UC"};
	//GetModuleFileNameA(NULL, path, 512);

	//char *last = strrchr(path, '\\');
	//*(last+1) = 0;
	//strcat(last, "WINSPD3D.UC");
	VLBase(path);

	
	return pV_CreateVerite(board, hwnd, pvhandle, path);
}

v_error V_DLLIMPORT V_EnumVeriteBoards(HWND hwnd, v_u32 board, v_verite_info* verite_info)
{
	if(!libraryLoaded)
		LoadLibrary();

#ifdef DUMP
	VL("V_EnumVeriteBoards");

	if(!pV_EnumVeriteBoards)
		Error("pV_EnumVeriteBoards");


	VL("Callng base function");
#endif


	return pV_EnumVeriteBoards(hwnd, board, verite_info);
}

v_error V_DLLIMPORT V_DestroyVerite(v_handle vhandle)
{
#ifdef DUMP
	VLS("V_DestroyVerite");

	if(!pV_DestroyVerite)
		Error("pV_DestroyVerite");
#endif

	return pV_DestroyVerite(vhandle);
}

v_u32 V_DLLIMPORT V_GetNumBuffers(v_buffer_group buffer_group)
{
#ifdef DUMP
	VLS("V_GetNumBuffers");
	if(!pV_GetNumBuffers)
		Error("pV_GetNumBuffers");
#endif

	return pV_GetNumBuffers(buffer_group);
}

v_u32* V_DLLIMPORT V_GetMemoryObjectAddress(v_memory memory)
{
	VLS("V_GetMemoryObjectAddress");
	if(!pV_GetMemoryObjectAddress)
		Error("pV_GetMemoryObjectAddress");

	return pV_GetMemoryObjectAddress(memory);
}

v_u32 V_DLLIMPORT V_GetUseDMA(v_handle vhandle)
{
#ifdef DUMP
	VL("V_GetUseDMA");
	if(!pV_GetUseDMA)
		Error("pV_GetUseDMA");
#endif

	return pV_GetUseDMA(vhandle);
}

v_error V_CreateBufferGroup(v_handle vhandle,
	v_buffer_group* pbuffer_group,
	v_u32* pmemsize,
	v_u32 buffer_mask,
	v_u32 num_buffers,
	v_u32 pixel_fmt,
	v_u32 width,
	v_u32 height)
{
#ifdef DUMP
	VLS("V_CreateBufferGroup");
	if(!pV_CreateBufferGroup)
		Error("pV_CreateBufferGroup");
#endif

	return pV_CreateBufferGroup(vhandle,
		pbuffer_group,
		pmemsize,
		buffer_mask,
		num_buffers,
		pixel_fmt,
		width,
		height);

}


void V_DLLIMPORT V_SetUserPrivate(v_handle vhandle, v_u32 priv)
{
#ifdef DUMP
	VLS("V_SetUserPrivate");
	if(!pV_SetUserPrivate)
		Error("pV_SetUserPrivate");
#endif

	pV_SetUserPrivate(vhandle, priv);
}

v_u32 V_DLLIMPORT V_GetUserPrivate(v_handle vhandle)
{
#ifdef DUMP
	VLS("V_GetUserPrivate");
	if(!pV_GetUserPrivate)
		Error("pV_GetUserPrivate");
#endif

	return pV_GetUserPrivate(vhandle);
}

v_u32 V_DLLIMPORT V_Linebytes(v_handle vhandle, v_u32 stride)
{
#ifdef DUMP
	VLS("V_Linebytes");
	if(!pV_Linebytes)
		Error("pV_Linebytes");
#endif

	return pV_Linebytes(vhandle, stride);
}

v_memory V_DLLIMPORT V_AllocMemoryObject(v_handle vhandle, v_u32* v_addr, v_u32 size_bytes)
{
#ifdef DUMP
	VLS("V_AllocMemoryObject");
	if(!pV_AllocMemoryObject)
		Error("pV_AllocMemoryObject");
#endif

	return pV_AllocMemoryObject(vhandle, v_addr, size_bytes);
}

v_error V_DLLIMPORT V_SetMemoryObject(v_memory memory, v_u32* v_addr, v_u32 size_bytes)
{
#ifdef DUMP
	VLS("V_SetMemoryObject");
	if(!pV_SetMemoryObject)
		Error("pV_SetMemoryObject");
#endif

	return pV_SetMemoryObject(memory, v_addr, size_bytes);
}


v_u32 V_DLLIMPORT V_GetMemoryObjectSize(v_memory memory)
{
#ifdef DUMP
	VLS("V_GetMemoryObjectSize");
	if(!pV_GetMemoryObjectSize)
		Error("pV_GetMemoryObjectSize");
#endif

	return pV_GetMemoryObjectSize(memory);
}

v_u32 V_DLLIMPORT V_GetMemoryObjectStatus(v_memory memory)
{
#ifdef DUMP
	VLS("V_GetMemoryObjectStatus");
	if(!pV_GetMemoryObjectStatus)
		Error("pV_GetMemoryObjectStatus");
#endif

	return pV_GetMemoryObjectStatus(memory);
}


void V_DLLIMPORT V_FreeMemoryObject(v_handle vhandle, v_memory memory)
{
#ifdef DUMP
	VLS("V_FreeMemoryObject");
	if(!pV_FreeMemoryObject)
		Error("pV_FreeMemoryObject");
#endif

	pV_FreeMemoryObject(vhandle, memory);
}

v_memory V_DLLIMPORT V_AllocLockedMem(v_handle vhandle, v_u32 size_bytes)
{
#ifdef DUMP
	VLS("V_AllocLockedMem");
	if(!pV_AllocLockedMem)
		Error("pV_AllocLockedMem");
#endif

	return pV_AllocLockedMem(vhandle, size_bytes);
}

v_error V_DLLIMPORT V_FreeLockedMem(v_handle vhandle, v_memory memory)
{
#ifdef DUMP
	VLS("V_FreeLockedMem");
	if(!pV_FreeLockedMem)
		Error("pV_FreeLockedMem");
#endif

	return pV_FreeLockedMem(vhandle, memory);
}

v_error V_DLLIMPORT V_LockPages(v_handle vhandle, v_memory memory)
{
#ifdef DUMP
	VLS("V_LockpPges");
	if(!pV_LockPages)
		Error("pV_LockPages");
#endif

	return pV_LockPages(vhandle, memory);
}

v_error V_DLLIMPORT V_UnlockPages(v_handle vhandle, v_memory memory)
{
#ifdef DUMP
	VLS("V_UnlockPages");
	if(!pV_UnlockPages)
		Error("pV_UnlockPages");
#endif

	return pV_UnlockPages(vhandle, memory);
}

v_cmdbuffer V_CreateCmdBuffer(v_handle vhandle, int dmalist_entries, int cmdlist_size)
{
#ifdef DUMP
	VLS("V_CreateCmdBuffer");
	if(!pV_CreateCmdBuffer)
		Error("pV_CreateCmdBuffer");
#endif

	return pV_CreateCmdBuffer(vhandle, cmdlist_size, dmalist_entries);
}

v_error V_DLLIMPORT V_IssueCmdBuffer(v_handle vhandle, v_cmdbuffer cmdbuffer)
{
#ifdef PUSHPOP
	for(size_t i = 0; i < bufferCount; i++)
	{
		if(bufferList[i] == cmdbuffer)
			break;
	}
	sprintf(String, "V_IssueCmdBuffer %u", i);
	VLS(String);


	//VLS("V_IssueCmdBuffer");
	if(!pV_IssueCmdBuffer)
	{
		Error("pV_IssueCmdBuffer");
	}
#endif


	return pV_IssueCmdBuffer(vhandle, cmdbuffer);
}

v_error V_DLLIMPORT V_IssueCmdBufferAsync(v_handle vhandle, v_cmdbuffer cmdbuffer)
{
#ifdef PUSHPOP
	for(size_t i = 0; i < bufferCount; i++)
	{
		if(bufferList[i] == cmdbuffer)
			break;
	}
	sprintf(String, "V_IssueCmdBufferAsync %u", i);
	VLS(String);

	//VLS("V_IssueCmdBufferAsync");
	if(!pV_IssueCmdBufferAsync)
		Error("pV_IssueCmdBufferAsync");
#endif

	return pV_IssueCmdBufferAsync(vhandle, cmdbuffer);
}

v_u32 V_DLLIMPORT V_QueryCmdBuffer(v_handle vhandle, v_cmdbuffer cmdbuffer)
{
	//VLS("V_QueryCmdBuffer");
#ifdef TEST
	if(!pV_QueryCmdBuffer)
		Error("pV_QueryCmdBuffer");
#endif

	return pV_QueryCmdBuffer(vhandle, cmdbuffer);
}

v_error V_DLLIMPORT V_DestroyCmdBuffer(v_cmdbuffer cmdBuffer)
{
#ifdef TEST
	VLS("V_DestroyCmdBuffer");
	if(!pV_DestroyCmdBuffer)
		Error("pV_DestroyCmdBuffer");
#endif

	return pV_DestroyCmdBuffer(cmdBuffer);
}

void V_DLLIMPORT V_ResetCmdBuffer(v_cmdbuffer cmdBuffer)
{
#ifdef TEST
	VLS("V_ResetCmdBuffer");
	if(!pV_ResetCmdBuffer)
		Error("pV_ResetCmdBuffer");
#endif

	pV_ResetCmdBuffer(cmdBuffer);
}
void V_DLLIMPORT V_SetCmdBufferCallBack(v_cmdbuffer cmdbuffer, v_cmdbuffer_callback pfn)
{
#ifdef TEST
	VLS("V_SetCmdBufferCallBack");
	if(!pV_SetCmdBufferCallBack)
		Error("pV_SetCmdBufferCallBack");
#endif

	pV_SetCmdBufferCallBack(cmdbuffer, pfn);
}

v_cmdbuffer_callback V_DLLIMPORT V_GetCmdBufferCallBack(v_cmdbuffer cmdbuffer)
{
	#ifdef TEST
	VLS("V_GetCmdBufferCallBack");
	if(!pV_GetCmdBufferCallBack)
		Error("pV_GetCmdBufferCallBack");
#endif
	//return (v_cmdbuffer_callback*)nativeCallback;
	//return (v_cmdbuffer_callback)cmdBufferMap[cmdbuffer];
	//return pV_GetCmdBufferCallBack(cmdbuffer);
#ifdef DIRECTFUNC
	return pV_GetCmdBufferCallBack(cmdbuffer);
#else
#ifdef DUMP
	for(size_t i =0; i < bufferMax; i++)
	{
		if(cmdbuffer == bufferList[i])
			break;
	}
	return callbacks[i];
#else
	return masterCallback;
#endif
#endif
}

v_u32 V_DLLIMPORT V_GetDMAEntries(v_memory memory, v_u32* v_addr, v_u32 size_words)
{
#ifdef TEST
	VLS("V_GetDMAEntries");
	if(!pV_GetDMAEntries)
		Error("pV_GetDMAEntries");
#endif

	return pV_GetDMAEntries(memory, v_addr, size_words);
}

v_u32* V_DLLIMPORT V_AddToCmdAndDMAList(v_cmdbuffer* cmdBuffer, v_u32 num_cmd_entries,
	v_u32 num_dma_entries)
{
#ifdef TEST
	VLS("V_AddToCmdAndDMAList");
	if(!pV_AddToCmdAndDMAList)
		Error("pV_AddToCmdAndDMAList");
#endif
	return pV_AddToCmdAndDMAList(cmdBuffer, num_cmd_entries, num_dma_entries);
}

v_error V_DLLIMPORT V_AddToDMAList(v_cmdbuffer* cmdBuffer, v_u32 fifo_port,
	v_memory memory, v_u32* v_addr, v_u32 size_words)
{
	#ifdef TEST
	VLS("V_AddToDMAList");
	if(!pV_AddToDMAList)
		Error("pV_AddToDMAList");
#endif
	return pV_AddToDMAList(cmdBuffer, fifo_port,
		memory, v_addr, size_words);
}

v_u32* V_DLLIMPORT V_AddToCmdList(v_cmdbuffer* cmdBuffer, v_u32 num_cmd_entries)
{
#ifdef TEST
	VLS("V_AddToCmdList");
	if(!pV_AddToCmdList)
		Error("pV_AddToCmdList");
#endif
	//*cmdBuffer = MassagedCallback(vhandle, *cmdBuffer);
	/*{
		for(size_t i = 0; i < bufferCount; i++)
		{
			if(bufferList[i] == *cmdBuffer)
				break;
		}
		sprintf(String, "V_AddToCmdList id %u, numCmds %u", i, num_cmd_entries);
		VLS(String);
	}*/
#define CMD_COUNTING
#ifdef CMD_COUNTING
	if(cmdCount >=1 && pNoFlush && !pNoFlush)
	{
		*cmdBuffer = MassagedCallback(vhandle, *cmdBuffer);
		cmdCount = 1;
	}
	else
	{
		cmdCount++;
	}
#endif
	return pV_AddToCmdList(cmdBuffer, num_cmd_entries);
}
v_u32 V_DLLIMPORT V_GetBufferStride(v_buffer_group buffer_group, v_u32 buffer)
{
#ifdef TEST
	VL("V_GetBufferStride");
	if(!pV_GetBufferStride)
		Error("pV_GetBufferStride");
#endif

	return pV_GetBufferStride(buffer_group, buffer);
}

v_u32 V_DLLIMPORT V_GetBufferLinebytes(v_buffer_group buffer_group, v_u32 buffer)
{
#ifdef TEST
	VLS("V_GetBufferLinebytes");
	if(!pV_GetBufferLinebytes)
		Error("pV_GetBufferLinebytes");
#endif

	return pV_GetBufferLinebytes(buffer_group, buffer);
}

v_handle V_DLLIMPORT V_GetCmdBufferHandle(v_cmdbuffer cmdbuffer)
{
#ifdef TEST
	VLS("V_GetCmdBufferHandle");
	if(!pV_GetCmdBufferHandle)
		Error("pV_GetCmdBufferHandle");
#endif

	return pV_GetCmdBufferHandle(cmdbuffer);
}

v_u32 V_DLLIMPORT V_GetDisplayType(v_handle vhandle)
{
#ifdef TEST
	VLS("V_GetDisplayType");
	if(!pV_GetDisplayType)
		Error("pV_GetDisplayType");
#endif

	return pV_GetDisplayType(vhandle);
}

v_error V_DLLIMPORT V_SwapBuffers(v_buffer_group buffer_group, v_u32 buffer1, v_u32 buffer2)
{
#ifdef TEST
	VLS("V_SwapBuffers");
	if(!pV_SwapBuffers)
		Error("pV_SwapBuffers");
#endif

	return pV_SwapBuffers(buffer_group, buffer1, buffer2);
}

v_foreignAddress V_DLLIMPORT V_GetBufferAddress(v_buffer_group buffer_group, v_u32 buffer)
{
#ifdef TEST
	VLS("V_GetBufferAddress");
	if(!pV_GetBufferAddress)
		Error("pV_GetBufferAddress");
#endif

	return pV_GetBufferAddress(buffer_group, buffer);
}

v_u32 V_DLLIMPORT V_IsBufferLost(v_handle vhandle, v_buffer_group buffer_group, v_u32 buffer)
{
#ifdef TEST
	VLS("V_IsBufferLost");
	if(!pV_IsBufferLost)
		Error("pV_IsBufferLost");
#endif

	return pV_IsBufferLost(vhandle, buffer_group, buffer);
}

v_error V_DLLIMPORT V_RestoreBuffer(v_handle vhandle, v_buffer_group buffer_group, v_u32 buffer)
{
#ifdef TEST
	VLS("V_RestoreBuffer");
	if(!pV_RestoreBuffer)
		Error("pV_RestoreBuffer");
#endif
	return pV_RestoreBuffer(vhandle, buffer_group, buffer);
}

v_error V_DLLIMPORT V_PointBufferGroup(v_handle vhandle,
	v_buffer_group* pbuffer_group,
	v_u32* pmemsize,
	v_u32 buffer_mask,
	v_u32 num_buffers,
	v_u32 pixel_fmt,
	v_u32 width,
	v_u32 height,
	v_foreignAddress addr)
{
#ifdef TEST
	VLS("V_PointBuffer");
	if(!pV_PointBufferGroup)
		Error("pV_PointBufferGroup");
#endif

	return pV_PointBufferGroup(vhandle,
	pbuffer_group,
	pmemsize,
	buffer_mask,
	num_buffers,
	pixel_fmt,
	width,
	height,
	addr);
}


v_error V_DLLIMPORT V_DestroyBufferGroup(v_handle vhandle, v_buffer_group buffer_group)
{
#ifdef TEST
	VLS("V_DestroyBufferGroup");
	if(!pV_DestroyBufferGroup)
		Error("pV_DestroyBufferGroup");
#endif

	return pV_DestroyBufferGroup(vhandle, buffer_group);
}

v_u32 V_DLLIMPORT V_GetBufferMask(v_buffer_group buffer_group)
{
#ifdef TEST
	VLS("V_GetBufferMask");
	if(!pV_GetBufferMask)
		Error("pV_GetBufferMask");
#endif

	return pV_GetBufferMask(buffer_group);
}

v_cmdbuffer MassagedCallback(v_handle vhandle, v_cmdbuffer cmdbuffer)
{
	//v_handle vhandle = (*cmdBuffer)->vhandle;
	//v_cmdbuffer_callback callback = (*cmdBuffer)->callback;
	//if (!vhandle->IsValid())
	//	ELOG(std::format("CommmanddListAppend buffer id {}, vhandle is invalid {:08X}", 
	//		(size_t)buff->id, (size_t)vhandle->magic));
	VLC("Massaged Callback (Entry)");
	//v_cmdbuffer freshBuffer=cmdbuffer;
	//void *func_ptr = cmdBufferMap[cmdbuffer];
#ifdef DUMP
	for(size_t i = 0; i < bufferCount; i++)
	{
		if(bufferList[i] == cmdbuffer)
			break;
	}
	sprintf(String, "MassagedCallback buffer entry cmdbuffer id %u", i);
	VLC(String);
	nativeCallback = callbacks[i];
#else
	nativeCallback = masterCallback;
#endif
	if(nativeCallback)
	{
		__asm {
			//push    ebx;
			//push    ecx;
			//push    esi;
			//push    edi;
			//push edx;
			pushad;
			mov eax, vhandle;
			mov edx, cmdbuffer;
			call nativeCallback;
			mov cmdbuffer, eax;
			//pop edx;
			popad;
			//pop     edi;
			//pop     esi;
			//pop     ecx;
			//pop     ebx;
		}
#ifdef DUMP
		for(size_t i = 0; i < bufferCount; i++)
		{
			if(bufferList[i] == cmdbuffer)
				break;
		}
#endif
		V_ResetCmdBuffer(cmdbuffer);
#ifdef DUMP
		sprintf(String, "MassagedCallback on exit cmdbuffer id %u", i);
		VLC(String);
#endif
		//VL("Massaged Callback (Exit success)");
		return cmdbuffer;
	}
	else
	{
		VLC("Massaged Callback (Exit, no callback)");
		Error("No cmdbuffer callback defined. Critical Error!");
		exit(1);
		//return NULL;
	}

}


v_error V_DLLIMPORT V_BltDisplayBuffer(v_handle vhandle,
	v_buffer_group dstgroup, v_u32 dstbuffer, v_rect* dstrect,
	v_buffer_group srcgroup, v_u32 srcbuffer, v_rect* srcrect)
{
#ifdef TEST
	VLS("V_BltDisplayBuffer ***");
	if(!pV_BltDisplayBuffer)
		VLS("pV_BltDisplayBuffer NULL");
#endif

	return pV_BltDisplayBuffer(vhandle,
	dstgroup, dstbuffer, dstrect,
	srcgroup, srcbuffer, srcrect);
}

v_error V_DLLIMPORT V_EnumDisplayModes(v_handle verite, v_enumdisplaymodes_callback callback, v_verite_displaymode* filter, void* userdata)
{
#ifdef TEST
	VLS("V_EnumDisplayModes ***");
	if(!pV_EnumDisplayModes)
		VLS("pV_EnumDisplayModes NULL");
#endif

	return pV_EnumDisplayModes(verite, callback, filter, userdata);
}



v_error V_DLLIMPORT V_GetAvailableVidMem(v_handle verite, v_u32* total, v_u32* free)
{
#ifdef TEST
	VLS("V_GetAvailableVidMem ***");
	if(!pV_GetAvailableVidMem)
		VLS("pV_GetAvailableVidMem NULL");
#endif

	return pV_GetAvailableVidMem(verite, total, free);
}

v_error V_DLLIMPORT V_GetBoardAddress(v_handle verite, v_u32* vaddr, v_foreignAddress* board_addr)
{
#ifdef TEST
	VLS("V_GetBoardAddress ***");
	if(!pV_GetBoardAddress)
		VLS("pV_GetBoardAddress NULL");
#endif

	return pV_GetBoardAddress(verite, vaddr, board_addr);
}

HDC V_DLLIMPORT V_GetBufferDC(v_buffer_group buffer_group)
{
#ifdef TEST
	VLS("V_GetBufferDC ***");
	if(!pV_GetBufferDC)
		VLS("pV_GetBufferDC");
#endif

	return pV_GetBufferDC(buffer_group);
}

v_error V_DLLIMPORT V_GetCmdBufferFreeSpace(v_cmdbuffer cmdbuffer, v_u32* pentries, v_u32* pdma_entries)
{
#ifdef TEST
	VLS("V_GetCmdBufferFreeSpace ***");
	if(!pV_GetCmdBufferFreeSpace)
		VLS("pV_GetCmdBufferFreeSpace is NULL");
#endif

	return pV_GetCmdBufferFreeSpace(cmdbuffer, pentries, pdma_entries);
}

v_error_handler V_DLLIMPORT V_GetErrorHandler(void)
{
#ifdef TEST
	VLS("V_GetErrorHandler ***");
	if(!pV_GetErrorHandler)
		VLS("pV_GetErrorHandler is NULL");
#endif

	return pV_GetErrorHandler();
}

v_error V_DLLIMPORT V_GetErrorText(v_error err, LPSTR s, int nbuff)
{
#ifdef TEST
	VLS("V_GetErrorText ***");
	if(!pV_GetErrorText)
		VLS("pV_GetErrorText is NULL");
#endif
	return pV_GetErrorText(err, s, nbuff);
}

v_error V_DLLIMPORT V_SetDisplayType(v_handle vhandle, v_u32 app_type)
{
#ifdef TEST
	VLS("V_SetDisplayType ***");
	if(!pV_SetDisplayType)
		VLS("pV_SetDisplayType");
#endif

	return pV_SetDisplayType(vhandle, app_type);
}

v_u32 V_DLLIMPORT V_Stride(v_handle vhandle, v_u32 linebytes)
{
#ifdef TEST
	VLS("V_Stride ***");
	if(!pV_Stride)
		VLS("pV_Stride");
#endif

	return pV_Stride(vhandle, linebytes);
}

v_error V_DLLIMPORT V_UnlockBuffer(v_handle vhandle, v_buffer_group buffer_group, v_u32 buffer)
{
#ifdef TEST
	VLS("V_UnlockBuffer ***");
	if(!pV_UnlockBuffer)
		VLS("pV_UnlockBuffer");
#endif
	return pV_UnlockBuffer(vhandle, buffer_group, buffer);
}

v_error V_DLLIMPORT V_SetDisplayMode(v_handle vhandle,
	v_u32 width, v_u32 height, v_u32 bpp,
	v_u32 refresh_rate)
{
#ifdef TEST
	VLS("V_SetDisplayMode ***");
	if(!pV_SetDisplayMode)
		VLS("pV_SetDisplayMode");
#endif

	return pV_SetDisplayMode(vhandle, width, height, bpp, refresh_rate);
}

v_error V_DLLIMPORT V_SetDisplayLinebytes(v_handle vhandle, v_u32 linebytes)
{
#ifdef TEST
	VLS("V_SetDisplayLinebytes ***");

	if(!pV_SetDisplayLinebytes)
		VLS("pV_SetDisplayLinebytes");
#endif

	return pV_SetDisplayLinebytes(vhandle, linebytes);
}

v_error V_ReleaseBufferDC(v_buffer_group buffer_group)
{
#ifdef TEST
	VLS("V_ReleaseBufferDC ***");
	if(!pV_ReleaseBufferDC)
		VLS("pV_ReleaseBufferDC");
#endif

	return pV_ReleaseBufferDC(buffer_group);
}


v_error V_DLLIMPORT V_RegisterErrorHandler(v_error_handler peh)
{
#ifdef TEST
	VLS("V_RegisterErrorHandler ***");
	if(!pV_RegisterErrorHandler)
		VLS("pV_RegisterErrorHandler");
#endif

	return pV_RegisterErrorHandler(peh);
}


v_error V_DLLIMPORT V_ReadBuffer(v_handle vhandle, v_buffer_group buffer_group,
	v_u32 buffer,
	v_u32 xorg,
	v_u32 yorg,
	v_u32 width,
	v_u32 height,
	v_u32 data_linebytes,
	v_u32* data)
{
#ifdef TEST
	VLS("V_ReadBuffer ***");

	if(!pV_ReadBuffer)
		VLS("pV_ReadBuffer");
#endif

	return pV_ReadBuffer(vhandle, buffer_group,
				buffer,
				xorg,
				yorg,
				width,
				height,
				data_linebytes,
				data);

}

v_error V_DLLIMPORT V_GetLastError(v_routine* proutine, v_error* perr, int* pexterr)
{
#ifdef TEST
	VLS("V_GetLastError ***");
	if(!pV_GetLastError)
		VLS("pV_GetLastError");
#endif
	return pV_GetLastError(proutine, perr, pexterr);
}

v_error V_DLLIMPORT V_GetLargestBuffer(v_handle verite, v_buffer_group* pbgroup, v_u32* pmemsize, v_u32 width)
{
#ifdef TEST
	VLS("V_GetLargestBuffer ***");
	if(!pV_GetLargestBuffer)
		VLS("pV_GetLargestBuffer");
#endif

	return pV_GetLargestBuffer(verite, pbgroup, pmemsize, width);
}

v_error V_DLLIMPORT V_GetFunctionName(v_routine routine, LPSTR s, int nbuff)
{
#ifdef TEST
	VLS("V_GetFunctionName ***");
	if(!pV_GetFunctionName)
		VLS("pV_GetFunctionName");
#endif

	return pV_GetFunctionName(routine, s, nbuff);
}